/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2009 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net>

	"HWGUI"
  	Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/
*MEMVAR _HMG_SYSDATA
*MEMVAR aResult

#include 'minigui.ch'
#include 'adodb.ch'

#define NM_FIRST	0
#define CDRF_DODEFAULT 0x00
#define CDDS_ITEMPOSTPAINT 65538

#define DL_BEGINDRAG	1157
#define DL_CANCELDRAG	1160
#define DL_DRAGGING	1158
#define DL_DROPPED	1159
#define DL_CURSORSET	0
#define DL_STOPCURSOR	1
#define DL_COPYCURSOR	2
#define DL_MOVECURSOR	3

#define CBN_CLOSEUP 8
#define CBN_DROPDOWN 7
#define WS_EX_TRANSPARENT	32
#define GWL_EXSTYLE	(-20)
#define HOLLOW_BRUSH	5
#define DTM_FIRST	0x1000
#define DTM_GETMONTHCAL	(DTM_FIRST+8)
#define DTN_CLOSEUP	(DTN_FIRST + 7)

#define TTN_NEEDTEXT	(-520)
#define NM_CUSTOMDRAW	(-12)
#DEFINE DC_BRUSH 18
#define WM_MOVE	3
#define WM_MOVING	534
#define LVN_BEGINDRAG	(-109)
#define WS_VISIBLE	0x10000000
#define WS_GROUP	0x20000
#define BS_AUTORADIOBUTTON	9
#define WS_CHILD	0x40000000
#define BS_NOTIFY	0x4000
#define GWL_STYLE	(-16)
#define CBN_EDITCHANGE	5
#define SIZE_MAXHIDE	4
#define SIZE_MAXIMIZED	2
#define SIZEFULLSCREEN	2
#define SIZE_MAXSHOW	3
#define SIZE_MINIMIZED	1
#define SIZEICONIC	1
#define SIZE_RESTORED	0
#define SIZENORMAL	0
#define	TBN_FIRST	(-700)
#define TBN_DROPDOWN	(TBN_FIRST-10)
#define WM_CTLCOLORLISTBOX	308
#define WM_CTLCOLORBTN	309
#define COLOR_WINDOW	5
#define COLOR_3DFACE	15
#define COLOR_BTNFACE	15
#define OPAQUE	2
#define DKGRAY_BRUSH	3
#define LVN_GETDISPINFO        (-150)
#define WM_HOTKEY	786
#define WM_CTLCOLOREDIT	307
#define WM_MOUSEWHEEL	0x20A
#define WM_MOUSEHOVER	0x2a1
#define EN_MSGFILTER	1792
#define DLGC_WANTCHARS	128
#define DLGC_WANTMESSAGE	4
#define MCN_FIRST           -750
#define MCN_LAST            -759
#define MCN_SELCHANGE       (MCN_FIRST + 1)
#define MCN_SELECT          (MCN_FIRST + 4)

#define WM_HELP	83
#define STN_CLICKED         0
#define STN_DBLCLK          1
#define STN_ENABLE          2
#define STN_DISABLE         3

#define SB_HORZ	0
#define NM_CLICK	(-2)
#define BS_DEFPUSHBUTTON	1
#define BM_SETSTYLE	244
#define SB_CTL	2
#define SB_VERT	1
#define SB_LINEUP	0
#define SB_LINEDOWN	1
#define SB_LINELEFT	0
#define SB_LINERIGHT	1
#define SB_PAGEUP	2
#define SB_PAGEDOWN	3
#define SB_PAGELEFT	2
#define SB_PAGERIGHT	3
#define SB_THUMBPOSITION	4
#define SB_THUMBTRACK	5
#define SB_ENDSCROLL	8
#define SB_LEFT	6
#define SB_RIGHT	7
#define SB_BOTTOM	7
#define SB_TOP	6

#define WM_VSCROLL                      0x0115

#define TVN_SELCHANGEDW	(-451)
#define TVN_SELCHANGED TVN_SELCHANGEDA
#define TVN_SELCHANGEDA	(-402)

//New define for TaskBar
#define WM_USER         0x0400
#define WM_TASKBAR      WM_USER+1043
#define ID_TASKBAR      0
#define WM_MOUSEMOVE      512    // 0x0200
#define WM_LBUTTONDOWN    513    // 0x0201
#define WM_LBUTTONUP      514    // 0x0202
#define WM_LBUTTONDBLCLK  515    // 0x203
#define WM_RBUTTONDOWN    516    // 0x0204
#define WM_RBUTTONUP      517    // 0x0205

#define WM_INITDIALOG	272
#define WM_ACTIVATEAPP	28
#define TB_AUTOSIZE	1057
#define WM_EXITSIZEMOVE	562
#define WM_ENTERSIZEMOVE	561
#define WM_NEXTDLGCTL	40
#define WM_GETDLGCODE	135
#define TRANSPARENT	1
#define GRAY_BRUSH	2
#define NULL_BRUSH	  5
#define WM_CTLCOLORSTATIC 312
#define WM_CTLCOLORDLG	310
#define BN_CLICKED	0
#define WM_VKEYTOITEM	46
#define LBN_KILLFOCUS	5
#define LBN_SETFOCUS	4
#define CBN_KILLFOCUS	4
#define CBN_SETFOCUS	3
#define BN_KILLFOCUS	7
#define BN_SETFOCUS	6
#define NM_SETFOCUS      -7
#define NM_KILLFOCUS	(-8)
#define WM_SYSKEYDOWN	260
#define LVN_KEYDOWN	(-155)
#define LVN_COLUMNCLICK	(-108)
#define NM_DBLCLK	(-3)
#define LBN_DBLCLK	2
#define TCN_SELCHANGE	(-551)
#define TCN_SELCHANGING	(-552)
#define DTN_FIRST	(-760)
#define DTN_DATETIMECHANGE (DTN_FIRST+1)
#define TB_ENDTRACK	8
#define WM_HSCROLL	276
#define CBN_SELCHANGE	1
#define LVN_ITEMCHANGED	(-101)
#define LBN_SELCHANGE	1
#define WM_PAINT	15
#define WM_ERASEBKGND  20
#define WM_DRAWITEM    43
#define WM_SHOWWINDOW	24
#define EN_SETFOCUS	256
#define EN_KILLFOCUS	512
#define WM_SETFOCUS	7
#define WM_KILLFOCUS	8
#define WM_UNDO	772
#define EM_SETMODIFY	185
#define WM_PASTE	770
#define WM_CHAR	258
#define EM_GETLINE	196
#define EM_SETSEL	177
#define WM_CLEAR	771
#define EM_GETSEL	176
#define EM_UNDO		199
#define EN_CHANGE       768    
#define EN_UPDATE       1024   
#define WM_ACTIVATE	6
#define WM_SIZING	532
#define MK_LBUTTON	1
#define WM_CONTEXTMENU	123
#define WM_TIMER	275
#define WM_SIZE		5
#define TBM_SETPOS	1029
#define TBM_GETPOS	1024
#define PBM_SETPOS	1026
#define WM_SYSCOMMAND	274
#define SC_CLOSE	61536
#define WM_KEYDOWN	256
#define WM_CLOSE        0x0010
#define WM_COMMAND      0x0111
#define WM_DESTROY      0x0002
#define WM_NOTIFY	78
#define WM_CREATE	1
#define WM_QUIT		18

#define TTM_SETTIPBKCOLOR   (WM_USER + 19)
#define TTM_SETTIPTEXTCOLOR (WM_USER + 20)


#define LVM_FIRST 0x1000
#define LVM_GETITEMCOUNT	(LVM_FIRST+4)
#define LVM_GETTOPINDEX	(LVM_FIRST+39)
#define LVM_GETCOUNTPERPAGE	(LVM_FIRST+40)

#define NM_RCLICK (NM_FIRST-5)

#define SB_CTL	2
#define CB_SHOWDROPDOWN 335

*------------------------------------------------------------------------------*
Init Procedure _BrowseAdo
*------------------------------------------------------------------------------*
	InstallEventHandler  	( '_BrowseAdoEventHandler' )	
	InstallMethodHandler 	( 'Refresh' 	,'_BrowseAdoSetRefresh' )
	InstallMethodHandler 	( 'SetFocus' 	,'_BrowseAdoSetfocus' )
	InstallMethodHandler	( 'Enable' 		,'_BrowseAdoEnable')
	InstallMethodHandler	( 'Disable'		,'_BrowseAdoDisable')
	InstallMethodHandler	( 'Resize'		,'_BrowseAdoSize')
	InstallMethodHandler	( 'MoveFirst'	,'_BrowseAdoMoveFirst')
	InstallMethodHandler	( 'BrowseBackcolor'	,'_BrowseSetBackColor')
	InstallPropertyHandler 	( 'Position' 	,'_AdoSetValue', '_AdoGetValue'  )
	InstallPropertyHandler	( 'Lock'		,'_BrowseAdoSetLock','_BrowseAdoGetLock')
	InstallPropertyHandler	('BrowseDelete'		,'_BrowseSetDelete','_BrowseGetDelete')
Return

***********************************************************************
FUNCTION _BrowseAdoEventHandler( hWnd, nMsg, wParam, lParam )
***********************************************************************
	LOCAL xRet:= NIL
	LOCAL I := 0
	
	DO CASE
***********************************************************************
	CASE nMsg == WM_SIZE
***********************************************************************
		i := ASCAN ( _HMG_SYSDATA [ 67  ] , hWnd )
		IF i > 0  
			IF _HMG_SYSDATA [ 263 ] == .T.
				IF wParam == SIZE_MAXIMIZED
					_DoWindowEventProcedure ( _HMG_SYSDATA [ 103  ]  [i] , i , '' )
				ELSEIF wParam == SIZE_MINIMIZED
					_DoWindowEventProcedure ( _HMG_SYSDATA [ 104  ]  [i] , i , '' )
				ELSE
					_DoWindowEventProcedure ( _HMG_SYSDATA [  76  ]  [i] , i , '' )
				ENDIF	
			ENDIF
			IF _HMG_SYSDATA [ 87 ] [i] > 0
				SizeRebar ( _HMG_SYSDATA [ 87 ] [i] )
				RedrawWindow  ( _HMG_SYSDATA [ 87 ] [i] )
			ENDIF
		ENDIF
		ControlCount 	:= LEN (_HMG_SYSDATA [3])
		FOR i = 1 TO ControlCount
        	IF _HMG_SYSDATA [4] [i] == hWnd
				IF _HMG_SYSDATA [1] [i] == "STATUSBAR"
					MoveWindow( _HMG_SYSDATA [3] [i] , 0 , 0 , 0 , 0 , .T. ) 
					SetStatusBarSize ( hWnd , _HMG_SYSDATA [3] [i] , _HMG_SYSDATA [ 20 ] [i] )
				ELSEIF _HMG_SYSDATA [1] [i] == "BROWSEADO"
					_BrowseAdoRefresh('','',i)
					_BrowseAdoAdjustScroll(i)
					xRet = 1
				ENDIF
        	ENDIF
        NEXT i
		RETURN xRet
	
***********************************************************************
	CASE nMsg == WM_VSCROLL
***********************************************************************
		i := ASCAN ( _HMG_SYSDATA [ 67  ] , hWnd )
		if i > 0	
			* Vertical ScrollBar Processing
			if _HMG_SYSDATA [ 91 ] [i] > 0 .And. lParam == 0
				If _HMG_SYSDATA [ 87 ] [i] > 0
					MsgMiniGuiError("SplitBox's Parent Window Can't Be a 'Virtual Dimensioned' Window (Use 'Virtual Dimensioned' SplitChild Instead). Program terminated" )
				EndIf
				If LoWord(wParam) == SB_LINEDOWN
					NewPos := GetScrollPos(hwnd,SB_VERT) + _HMG_SYSDATA [ 345 ]
					SetScrollPos ( hwnd , SB_VERT , NewPos , _HMG_SYSDATA [ 345 ] )
				ElseIf LoWord(wParam) == SB_LINEUP	
				    NewPos := GetScrollPos(hwnd,SB_VERT) - _HMG_SYSDATA [ 345 ] 
					SetScrollPos ( hwnd , SB_VERT , NewPos , _HMG_SYSDATA [ 345 ] )
				ElseIf LoWord(wParam) == SB_TOP	
				    NewPos := 0
					SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )
				ElseIf LoWord(wParam) == SB_BOTTOM
				    NewPos := GetScrollRangeMax(hwnd,SB_VERT) 
					SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )
				ElseIf LoWord(wParam) == SB_PAGEUP
				    NewPos := GetScrollPos(hwnd,SB_VERT) - 20 
					SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )
				ElseIf LoWord(wParam) == SB_PAGEDOWN	
				    NewPos := GetScrollPos(hwnd,SB_VERT) + 20 
					SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )
				ElseIf LoWord(wParam) == SB_THUMBPOSITION
					NewPos := HIWORD(wParam)
					SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )
				EndIf

				If _HMG_SYSDATA [ 92 ] [i] > 0
			        NewHPos := GetScrollPos ( hwnd , SB_HORZ )  
				Else
			        NewHPos := 0
				EndIf

				* Control Repositioning

				If LoWord(wParam) == SB_THUMBPOSITION .Or. LoWord(wParam) == SB_LINEDOWN .Or. LoWord(wParam) == SB_LINEUP .or. LoWord(wParam) == SB_PAGEUP .or. LoWord(wParam) == SB_PAGEDOWN  .or. LoWord(wParam) == SB_BOTTOM  .or. LoWord(wParam) == SB_TOP 
					FOR x := 1 TO LEN ( _HMG_SYSDATA [3] )
						If _HMG_SYSDATA [4] [x] == hwnd
							If _HMG_SYSDATA [1] [x] == 'BROWSEADO'
								MoveWindow (_HMG_SYSDATA [  3 ] [x], ;
											_HMG_SYSDATA [ 19 ] [x] - NewHPos	, ;
											_HMG_SYSDATA [ 18 ] [x] - NewPos , ;
											_HMG_SYSDATA [ 20 ] [x] - GETVSCROLLBARWIDTH() , ;
											_HMG_SYSDATA [ 21 ] [x] , .t. )
								MoveWindow (_HMG_SYSDATA [  5 ] [x], ;
											_HMG_SYSDATA [ 19 ] [x] + _HMG_SYSDATA [ 20 ] [x] - GETVSCROLLBARWIDTH()  - NewHPos	, ;
											_HMG_SYSDATA [ 18 ] [x] - NewPos , GETVSCROLLBARWIDTH() , ;
											GetWIndowHeight(_HMG_SYSDATA [  5 ] [x]) , .t. )
								MoveWindow (_HMG_SYSDATA [ 39 ] [x] [1]	, ;
											_HMG_SYSDATA [ 19 ] [x] + _HMG_SYSDATA [ 20 ] [x] - GETVSCROLLBARWIDTH() - NewHPos	, ;
											_HMG_SYSDATA [ 18 ] [x] +_HMG_SYSDATA [ 21 ] [x] - GetHScrollBarHeight () - NewPos,;
											GetWindowWidth(_HMG_SYSDATA [ 39 ] [x][1]), ;
											GetWindowHeight(_HMG_SYSDATA [ 39 ] [x][1])  , .t. )
								ReDrawWindow ( _HMG_SYSDATA [3] [x] )				
							Else
								MoveWindow (_HMG_SYSDATA [  3 ] [x] , ;
											_HMG_SYSDATA [ 19 ] [x] - NewHPos , ;
											_HMG_SYSDATA [ 18 ] [x] - NewPos , ;
											_HMG_SYSDATA [ 20 ] [x] ,;
											_HMG_SYSDATA [ 21 ] [x] , .t. )
							EndIf
						EndIf
					Next x
					ReDrawWindow ( hwnd )
				EndIf
			EndIf
			
			If LoWord(wParam) == SB_LINEDOWN
				_DoWindowEventProcedure ( _HMG_SYSDATA [ 95 ] [i] , i , '' )
			ElseIf LoWord(wParam) == SB_LINEUP	
				_DoWindowEventProcedure ( _HMG_SYSDATA [ 94 ] [i] , i , '' )
			ElseIf LoWord(wParam) == SB_THUMBPOSITION ;
				.or. ;
				LoWord(wParam) == SB_PAGEUP ;
				.or. ;
				LoWord(wParam) == SB_PAGEDOWN ;
				.or. ;
				LoWord(wParam) == SB_TOP ;
				.or. ;
				LoWord(wParam) == SB_BOTTOM 

				_DoWindowEventProcedure ( _HMG_SYSDATA [ 99 ] [i] , i , '' )
			EndIf
		EndIf		
		i := aScan ( _HMG_SYSDATA [  5 ] , lParam )
		if i > 0
			if _HMG_SYSDATA [1] [i] == 'BROWSEADO'

				If LoWord(wParam) == SB_LINEDOWN
					setfocus( _HMG_SYSDATA [3] [i] )
					InsertDown()
				EndIf
				If LoWord(wParam) == SB_LINEUP	
					setfocus( _HMG_SYSDATA [3] [i] )
					InsertUp()
				EndIf
				If LoWord(wParam) == SB_PAGEUP 
					setfocus( _HMG_SYSDATA [3] [i] )
					InsertPrior()
				EndIf
				If LoWord(wParam) == SB_PAGEDOWN
					setfocus( _HMG_SYSDATA [3] [i] )
					InsertNext()
				EndIf
				If LoWord(wParam) == SB_THUMBPOSITION 
					BrowseArea 	:= _HMG_SYSDATA [ 22 ] [i]
					BackRec 	:= BrowseArea:AbsolutePosition
					RecordCount := BrowseArea:Recordcount
					SkipCount 	:= Int ( HIWORD(wParam) * RecordCount / GetScrollRangeMax ( _HMG_SYSDATA [  5 ] [ i ] , 2 ) )
					If SkipCount > ( RecordCount / 2 )
						BrowseArea:Movelast()
        				BrowseArea:Move( - ( RecordCount - SkipCount ))
					Else
						BrowseArea:MoveFirst()
	        			BrowseArea:Move(SkipCount)
					EndIf
					If BrowseArea:Eof()
						BrowseArea:Movelast()
					EndIf
					nr := BrowseArea:AbsolutePosition
					SetScrollPos ( _HMG_SYSDATA [  5 ] [i] , 2 , HIWORD(wParam) , 1 )
					BrowseArea:AbsolutePosition := nr /*BackRec*/
					_BrowseAdoSetValue ( '' , '' , nr , i )
					_BrowseAdoAdjustScroll(i)
					RETURN 0
				EndIf
			EndIf
		EndIf

***********************************************************************
	case nMsg == WM_HSCROLL
***********************************************************************

		i := aScan ( _HMG_SYSDATA [ 67  ] , hWnd )
		if i > 0
			* Horizontal ScrollBar Processing

			if _HMG_SYSDATA [ 92 ] [i] > 0 .And. lParam == 0
				If _HMG_SYSDATA [ 87 ] [i] > 0
					MsgMiniGuiError("SplitBox's Parent Window Can't Be a 'Virtual Dimensioned' Window (Use 'Virtual Dimensioned' SplitChild Instead). Program terminated" )
				EndIf
				If LoWord(wParam) == SB_LINERIGHT
				        NewHPos := GetScrollPos(hwnd,SB_HORZ) + _HMG_SYSDATA [ 345 ]
					SetScrollPos ( hwnd , SB_HORZ , NewHPos , _HMG_SYSDATA [ 345 ] )
				ElseIf LoWord(wParam) == SB_LINELEFT	
				        NewHPos := GetScrollPos(hwnd,SB_HORZ) - _HMG_SYSDATA [ 345 ] 
					SetScrollPos ( hwnd , SB_HORZ , NewHPos , _HMG_SYSDATA [ 345 ] )
				ElseIf LoWord(wParam) == SB_PAGELEFT	
				        NewHPos := GetScrollPos(hwnd,SB_HORZ) - 20 
					SetScrollPos ( hwnd , SB_HORZ , NewHPos , 1 )
				ElseIf LoWord(wParam) == SB_PAGERIGHT	
				        NewHPos := GetScrollPos(hwnd,SB_HORZ) + 20 
					SetScrollPos ( hwnd , SB_HORZ , NewHPos , 1 )
				ElseIf LoWord(wParam) == SB_THUMBPOSITION
					NewHPos := HIWORD(wParam)
					SetScrollPos ( hwnd , SB_HORZ , NewHPos , 1 )
				EndIf
				If _HMG_SYSDATA [ 91 ] [i] > 0
					NewVPos := GetScrollPos ( hwnd , SB_VERT )  
				Else
				    NewVPos := 0
				EndIf

				* Control Repositioning
				
				If LoWord(wParam) == SB_THUMBPOSITION .Or. LoWord(wParam) == SB_LINELEFT .Or. LoWord(wParam) == SB_LINERIGHT .OR. LoWord(wParam) == SB_PAGELEFT	.OR. LoWord(wParam) == SB_PAGERIGHT
					For x := 1 To Len ( _HMG_SYSDATA [3] )
						If _HMG_SYSDATA [4] [x] == hwnd
							If _HMG_SYSDATA [1] [x] == 'BROWSEADO'
								MoveWindow ( _HMG_SYSDATA [3] [x] 	, _HMG_SYSDATA [ 19 ] [x] - NewHPos				, _HMG_SYSDATA [ 18 ] [x] - NewVPos , _HMG_SYSDATA [ 20 ] [x] - GETVSCROLLBARWIDTH()	, _HMG_SYSDATA [ 21 ] [x] , .t. )
								MoveWindow ( _HMG_SYSDATA [  5 ] [x] 	, _HMG_SYSDATA [ 19 ] [x] + _HMG_SYSDATA [ 20 ] [x] - GETVSCROLLBARWIDTH() - NewHPos	, _HMG_SYSDATA [ 18 ] [x] - NewVPos , GetWindowWidth(_HMG_SYSDATA [  5 ] [x])			, GetWindowHeight(_HMG_SYSDATA [  5 ] [x]) , .t. )
								MoveWindow ( _HMG_SYSDATA [ 39 ] [x] [1]	, _HMG_SYSDATA [ 19 ] [x] + _HMG_SYSDATA [ 20 ] [x] - GETVSCROLLBARWIDTH() - NewHPos	, _HMG_SYSDATA [ 18 ] [x] +_HMG_SYSDATA [ 21 ][x] - GethScrollBarHeight() - NewVPos , GetWindowWidth(_HMG_SYSDATA [ 39 ] [x] [1])			, GetWindowHeight (_HMG_SYSDATA [ 39 ] [x][1]) , .t. )
								ReDrawWindow ( _HMG_SYSDATA [3] [x] )
							EndIf
						EndIf
					Next x					
					RedrawWindow ( hwnd )					
				EndIf
			EndIf
				
			If LoWord(wParam) == SB_LINERIGHT
				_DoWindowEventProcedure ( _HMG_SYSDATA [ 97 ] [i] , i , '' )
			ElseIf LoWord(wParam) == SB_LINELEFT	
				_DoWindowEventProcedure ( _HMG_SYSDATA [ 96 ] [i] , i , '' )
			ElseIf	LoWord(wParam) == SB_THUMBPOSITION ;
				.or. ;
				LoWord(wParam) == SB_PAGELEFT ;
				.or. ;
				LoWord(wParam) == SB_PAGERIGHT	

				_DoWindowEventProcedure ( _HMG_SYSDATA [ 98 ] [i] , i , '' )
			EndIf			
			RETURN 1
		EndIf	
		
***********************************************************************
	CASE nMsg == WM_COMMAND
***********************************************************************			
		i := Ascan ( _HMG_SYSDATA [3] , GetFocus() )
		IF  i > 0   
			* Browse Enter ..........................................
			IF _HMG_SYSDATA [1] [i] = "BROWSEADO" .and. lparam == 0 .and. wparam == 1
				IF _HMG_SYSDATA [9] [i] == .F. 
					IF _HMG_SYSDATA[22][i]:AbsolutePosition =-1 .or. _HMG_SYSDATA[22][i]:AbsolutePosition = -2 .OR. _HMG_SYSDATA[22][i]:AbsolutePosition = -3
						_HMG_SYSDATA [ 39 ] [i] [2] := .T.
					ELSE
						_HMG_SYSDATA [ 39 ] [i] [2] := .F.
					ENDIF
					AdoProcessInPlaceKbdEdit(i)	
				ELSE 
					_DoControlEventProcedure ( _HMG_SYSDATA [ 16 ] [i] , i )
				ENDIF
				RETURN 0				
			ENDIF
		ENDIF
***********************************************************************
	case nMsg == WM_NOTIFY 
***********************************************************************

		i := Ascan ( _HMG_SYSDATA [3] , GetHwndFrom (lParam) )

		if i > 0
			* Process Browse .....................................
			if (_HMG_SYSDATA [1] [i] = "BROWSEADO")
				If	GetNotifyCode ( lParam ) == NM_RCLICK
					If LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) > 0 
						DeltaSelect := LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) - ascan ( _HMG_SYSDATA [ 32 ] [i] , _HMG_SYSDATA [  8 ] [i] )
						_HMG_SYSDATA [  8 ] [i] :=  _HMG_SYSDATA [ 32 ] [i] [ LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) ]
						_BrowseAdoVscrollFastUpdate ( i , DeltaSelect )
						_BrowseAdoOnChange (i)
						_BrowseAdoAdjustScroll(i)
						RETURN 1
					EndIf
				EndIf

 				* Browse Refresh On Column Size ..............

				If	GetNotifyCode ( lParam ) == -12
					hws := 0
					hwm := .F.
					For x := 1 To Len ( _HMG_SYSDATA [  6 ] [i] )
						hws := hws + ListView_GetColumnWidth ( _HMG_SYSDATA [3] [i] , x - 1 )
						If _HMG_SYSDATA [  6 ] [i] [x] != ListView_GetColumnWidth ( _HMG_SYSDATA [3] [i] , x - 1 )
							hwm := .T.
							_HMG_SYSDATA [  6 ] [i] [x] := ListView_GetColumnWidth ( _HMG_SYSDATA [3] [i] , x - 1 )
							_BrowseAdoRefresh('','',i)	
						EndIf
					Next x
					* Browse ReDraw Vertical ScrollBar If Needed ...
					If _HMG_SYSDATA [ 5 ] [i] != 0 .and. hwm == .T.
						if hws > _HMG_SYSDATA [ 20 ][i] - GETVSCROLLBARWIDTH() - 4
							MoveWindow ( _HMG_SYSDATA [  5 ] [i] , _HMG_SYSDATA [ 19 ][i]+_HMG_SYSDATA [ 20 ][i] - GETVSCROLLBARWIDTH() , _HMG_SYSDATA [ 18 ][i] , GETVSCROLLBARWIDTH() , _HMG_SYSDATA [ 21 ][i] - GETHSCROLLBARHEIGHT() , .t. )
							MoveWindow ( _HMG_SYSDATA [ 39 ] [i] [1], _HMG_SYSDATA [ 19 ][i]+_HMG_SYSDATA [ 20 ][i] - GETVSCROLLBARWIDTH() , _HMG_SYSDATA [ 18 ][i] + _HMG_SYSDATA [ 21 ][i] - GETHSCROLLBARHEIGHT() , GETVSCROLLBARWIDTH() , GETHSCROLLBARHEIGHT() , .t. )
						Else
							MoveWindow ( _HMG_SYSDATA [  5 ] [i] , _HMG_SYSDATA [ 19 ][i]+_HMG_SYSDATA [ 20 ][i] - GETVSCROLLBARWIDTH() , _HMG_SYSDATA [ 18 ][i] , GETVSCROLLBARWIDTH() , _HMG_SYSDATA [ 21 ][i] , .t. )
							MoveWindow ( _HMG_SYSDATA [ 39 ] [i] [1], _HMG_SYSDATA [ 19 ][i]+_HMG_SYSDATA [ 20 ][i] - GETVSCROLLBARWIDTH() , _HMG_SYSDATA [ 18 ][i] + _HMG_SYSDATA [ 21 ][i] - GETHSCROLLBARHEIGHT() , 0 , 0 , .t. )
						EndIf
					EndIf
					RETURN 1
				EndIf        		
*-------------			
				If GetNotifyCode ( lParam ) = NM_CUSTOMDRAW
					r := GetDs ( lParam )
					if r <> -1		
						Return r
					else
						a := GetRc (lParam)
						MaxBrowseRows := Len ( _HMG_SYSDATA [ 32 ] [i] )
						MaxBrowseCols := Len ( _HMG_SYSDATA [ 31 ] [i] )
						if a[1] >= 1 .and. a[1] <= MaxBrowseRows .and. a[2] >= 1 .and. a[2] <= MaxBrowseCols 
							aTemp 	:= _HMG_SYSDATA [40] [I] [6]
							aTemp2 	:= _HMG_SYSDATA [40] [I] [7]
							if valtype ( aTemp ) = 'A' .and. valtype ( aTemp2 ) <> 'A'
								if len ( aTemp ) >= a[1]
									if aTemp [a[1]] [a[2]] <> -1
										Return SetBcBc ( lParam , aTemp [a[1]] [a[2]] , RGB(0,0,0) )
									else
										Return SETBRCCD(LpARAM)
									endif
								else
									Return SETBRCCD(LpARAM)
								endif
							elseif valtype ( aTemp ) <> 'A' .and. valtype ( aTemp2 ) = 'A'
								if len ( aTemp2 ) >= a[1]
									if aTemp2 [a[1]] [a[2]] <> -1
										Return SetBcBc ( lParam , RGB(255,255,255) , aTemp2 [a[1]] [a[2]] )
									else
										Return SETBRCCD(LpARAM)
									endif
								else
									Return SETBRCCD(LpARAM)
								endif
							elseif valtype ( aTemp ) = 'A' .and. valtype ( aTemp2 ) = 'A'
								if len ( aTemp ) >= a[1] .and. len ( aTemp2 ) >= a[1]
									if aTemp [a[1]] [a[2]] <> -1
										Return SetBcBc ( lParam , aTemp [a[1]] [a[2]] , aTemp2 [a[1]] [a[2]] )
									else
										Return SETBRCCD(LpARAM)
									endif
								else
									Return SETBRCCD(LpARAM)
								endif
							endif
						else
							Return SETBRCCD(LpARAM)
						endif
					endif
				EndIf	
				
				* Browse Click ................................
				If	GetNotifyCode ( lParam ) == NM_CLICK  .or. GetNotifyCode ( lParam ) == LVN_BEGINDRAG	
					If LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) > 0 
						DeltaSelect := LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) - ascan ( _HMG_SYSDATA [ 32 ] [i] , _HMG_SYSDATA [  8 ] [i] )
						_HMG_SYSDATA [  8 ] [i] :=  _HMG_SYSDATA [ 32 ] [i] [ LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) ]
						_BrowseAdoVscrollFastUpdate ( i , DeltaSelect )
						_BrowseAdoOnChange (i)
						return 1
					EndIf
				EndIf

				* Browse Key Handling .........................
				If GetNotifyCode ( lParam ) = LVN_KEYDOWN
					DO CASE
					CASE GetGridvKey(lParam) == 65 // A 
						RETURN 1
					CASE GetGridvKey(lParam) == 46 // DEL
						IF _HMG_SYSDATA [9] [i] == .F. .AND. _HMG_SYSDATA[25][I] == .T.
						    IF MsgYesNo (_HMG_SYSDATA [ 137 ] [1] , _HMG_SYSDATA [ 137 ] [2] ) == .t.
								_BrowseAdoDelete('','',i)
								RETURN 1
							ENDIF
						ENDIF
					CASE GetGridvKey(lParam) == 36 // HOME
						_BrowseAdoHome('','',i)
						Return 1				
					CASE GetGridvKey(lParam) == 35 // END
						_BrowseAdoEnd('','',i)
						Return 1				
					CASE GetGridvKey(lParam) == 33 // PGUP
						_BrowseAdoPrior('','',i)
						Return 1				
					CASE GetGridvKey(lParam) == 34 // PGDN
						_BrowseAdoNext('','',i)
						Return 1				
					CASE GetGridvKey(lParam) == 38 // UP
						_BrowseAdoUp('','',i)
						Return 1				
					CASE GetGridvKey(lParam) == 40 // DOWN
						_BrowseAdoDown('','',i)
						Return 1				
					ENDCASE
					Return 0
				EndIf

				* Browse Double Click .........................

				If GetNotifyCode ( lParam ) == NM_DBLCLK  
					_PushEventInfo()
					_HMG_SYSDATA [ 194 ] := ascan ( _HMG_SYSDATA [ 67  ] , _HMG_SYSDATA [4][i] )
					_HMG_SYSDATA [ 231 ] := 'C'
					_HMG_SYSDATA [ 203 ] := i
					_HMG_SYSDATA [ 316 ] :=  _HMG_SYSDATA [  66 ] [ _HMG_SYSDATA [ 194 ] ] 
					_HMG_SYSDATA [ 317 ] :=  _HMG_SYSDATA [2] [_HMG_SYSDATA [ 203 ]]

					r := ListView_HitTest ( _HMG_SYSDATA [3] [i] , GetCursorRow() - GetWindowRow ( _HMG_SYSDATA [3] [i] )  , GetCursorCol() - GetWindowCol ( _HMG_SYSDATA [3] [i] ) )
					If r [2] == 1
						ListView_Scroll( _HMG_SYSDATA [3] [i] ,	-10000  , 0 ) 
						r := ListView_HitTest ( _HMG_SYSDATA [3] [i] , GetCursorRow() - GetWindowRow ( _HMG_SYSDATA [3] [i] )  , GetCursorCol() - GetWindowCol ( _HMG_SYSDATA [3] [i] ) )
					Else
						r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , r[1] - 1 , r[2] - 1 )
						
                                                      *	CellCol				CellWidth				
						xs :=	( ( _HMG_SYSDATA [ 19 ] [i] + r [2] ) +( r[3] ))  -  ( _HMG_SYSDATA [ 19 ] [i] + _HMG_SYSDATA [ 20 ] [i] )
						xd := 20
						If xs > -xd 
							ListView_Scroll( _HMG_SYSDATA [3] [i] ,	xs + xd , 0 ) 
						Else
							If r [2] < 0
								ListView_Scroll( _HMG_SYSDATA [3] [i] , r[2]	, 0 )
							EndIf
						EndIf
							r := ListView_HitTest ( _HMG_SYSDATA [3] [i] , GetCursorRow() - GetWindowRow ( _HMG_SYSDATA [3] [i] )  , GetCursorCol() - GetWindowCol ( _HMG_SYSDATA [3] [i] ) )
						EndIf

						_HMG_SYSDATA [ 195 ] := r[1]
						_HMG_SYSDATA [ 196 ] := r[2]
						If r [2] == 1
							r := LISTVIEW_GETITEMRECT ( _HMG_SYSDATA [3] [i]  , r[1] - 1 )
						Else
							r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , r[1] - 1 , r[2] - 1 )
						EndIf
						_HMG_SYSDATA [ 197 ] := _HMG_SYSDATA [ 18 ] [i] + r [1]
						_HMG_SYSDATA [ 198 ] := _HMG_SYSDATA [ 19 ] [i] + r [2]
						_HMG_SYSDATA [ 199 ] := r[3]
						_HMG_SYSDATA [ 200 ] := r[4]
						_HMG_SYSDATA [ 340 ] := 1
						if _HMG_SYSDATA [ 9 ] [i] == .F. 
							_BrowseAdoEdit ( _HMG_SYSDATA [3][i] , _HMG_SYSDATA [ 39 ] [i] [4] , _HMG_SYSDATA [ 39 ] [i] [5] , _HMG_SYSDATA [ 39 ] [i] [3] , _HMG_SYSDATA [  9 ] [i] , .f. , _HMG_SYSDATA [ 15 ] [i] , _HMG_SYSDATA [ 39 ] [i] [7] )  							
						Else 
							if valtype(_HMG_SYSDATA [ 16 ] [i]  )=='B'
								Eval( _HMG_SYSDATA [ 16 ] [i]  )
							EndIf
						Endif

						_PopEventInfo()
						_HMG_SYSDATA [ 195 ] := 0
						_HMG_SYSDATA [ 196 ] := 0
						_HMG_SYSDATA [ 197 ] := 0
						_HMG_SYSDATA [ 198 ] := 0
						_HMG_SYSDATA [ 199 ] := 0
						_HMG_SYSDATA [ 200 ] := 0
						RETURN 1
					EndIf

					* Browse LostFocus ............................
                	
					If GetNotifyCode ( lParam ) = NM_KILLFOCUS
						_DoControlEventProcedure ( _HMG_SYSDATA [10] [i] , i )
						Return 0
					EndIf
                	
					* Browse GotFocus ..............................
                	
					If GetNotifyCode ( lParam ) = NM_SETFOCUS
						VirtualChildControlFocusProcess ( _HMG_SYSDATA [3] [i] , _HMG_SYSDATA [4] [i] )
						_DoControlEventProcedure ( _HMG_SYSDATA [ 11 ] [i] , i )
						Return 0
					EndIf
                	
					* Browse Header Click .........................
                	
					If GetNotifyCode ( lParam ) =  LVN_COLUMNCLICK
						if ValType ( _HMG_SYSDATA [ 17 ] [i] ) == 'A'
							lvc := GetGridColumn(lParam) + 1
							if len (_HMG_SYSDATA [ 17 ] [i]) >= lvc
								_DoControlEventProcedure ( _HMG_SYSDATA [ 17 ] [i] [lvc] , i )
							EndIf					
						EndIf
						Return 0
					EndIf

			EndIf
		ENDIF
***********************************************************************
	case nMsg == WM_MOUSEWHEEL
***********************************************************************
		*- ACTUALIZA LA BARRA DE SCROLL		
		hwnd := 0

		i := ascan ( _HMG_SYSDATA [ 67  ] , GetFocus() )

		if i > 0 

			If _HMG_SYSDATA [ 91 ] [i] > 0
				hwnd := _HMG_SYSDATA [ 67  ] [i]
			EndIf

		Else

			i := ascan ( _HMG_SYSDATA [3] , GetFocus() )
			If i > 0

				x := ascan ( _HMG_SYSDATA [ 67  ] , _HMG_SYSDATA [4] [i] )
				
				if x > 0
					If _HMG_SYSDATA [ 91 ] [x] > 0
						hwnd := _HMG_SYSDATA [ 67  ] [x]
						i := x
					EndIf
				EndIf
			EndIf

		EndIf

		If hwnd != 0

			If HIWORD(wParam) == 120
				if GetScrollPos(hwnd,SB_VERT) < 25
					SendMessage ( hwnd , WM_VSCROLL , SB_TOP , 0 )
				Else
					SendMessage ( hwnd , WM_VSCROLL , SB_PAGEUP , 0 )
				endif
			Else
				if GetScrollPos(hwnd,SB_VERT) >= GetScrollRangeMax ( hwnd , SB_VERT ) - 10
					SendMessage ( hwnd , WM_VSCROLL , SB_BOTTOM , 0 )
				else
					SendMessage ( hwnd , WM_VSCROLL , SB_PAGEDOWN , 0 )
				endif
			EndIf
			RETURN 1
		EndIf
			
	ENDCASE
RETURN xRet

***********************************************************************
PROCEDURE _DefineBrowseAdo ( ControlName, ;
			ParentForm, ;
			x, ;
			y, ;
			w, ;
			h, ;
			aHeaders, ;
			aWidths, ;
			aFields , ;
			value, ;
			fontname, ;
			fontsize , ;
			tooltip , ;
			change , ;
			dblclick , ;
			aHeadClick , ;
			gotfocus , ;
			lostfocus , ;
			WorkArea , ;
			Delete, ;
			nogrid, ;
			aImage, ;
			aJust , ;
			HelpId , ;
			bold , ;
			italic , ;
			underline , ;
			strikeout , ;
			break , ;
			backcolor , ;
			fontcolor , ;
			lock , ;
			inplace , ;
			novscroll , ;
			appendable , ;
			readonly , ;
			valid , ;
			validmessages , ;
			edit , ;
			dynamicbackcolor , ;
			aWhenFields , ;
			dynamicforecolor , ;
			inputmask , ;
			format , ;
			inputitems , displayitems , aHeaderImages ;
			)
***********************************************************************
	LOCAL i , cParentForm , mVar , ix, wBitmap , z , ScrollBarHandle , DeltaWidth , k := 0
	LOCAL cParentTabName
	      
	LOCAL ControlHandle
	LOCAL FontHandle
	LOCAL hsum := 0
	LOCAL ScrollBarButtonHandle
	LOCAL nHeaderImageListHandle
	
	InPlace 		:= .T.
	
	IF VALTYPE( WorkArea ) != 'O'
		MsgMiniGuiError("RecordSet not defined" )
	ENDIF
	
	if _HMG_SYSDATA [ 264 ] = .T.
		ParentForm := _HMG_SYSDATA [ 223 ]
		if .Not. Empty (_HMG_SYSDATA [ 224 ]) .And. ValType(FontName) == "U"
			FontName := _HMG_SYSDATA [ 224 ]
		EndIf
		if .Not. Empty (_HMG_SYSDATA [ 182 ]) .And. ValType(FontSize) == "U"
			FontSize := _HMG_SYSDATA [ 182 ]
		EndIf
	endif
	if _HMG_SYSDATA [ 183 ] > 0
		x 				:= x + _HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]]
		y 				:= y + _HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]] 
		ParentForm 		:= _HMG_SYSDATA [ 332 ] [_HMG_SYSDATA [ 183 ]]
		cParentTabName 	:= _HMG_SYSDATA [ 225 ] 
	EndIf

	If .Not. _IsWindowDefined (ParentForm)
		MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated" )
	Endif

	If _IsControlDefined (ControlName,ParentForm)
		MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentForm + " Already defined. Program Terminated" )
	endif

	ix 			:= GetFormIndex (ParentForm)
	mVar		:= '_' + ParentForm + '_' + ControlName
	cParentForm := ParentForm
	ParentForm 	:= GetFormHandle (ParentForm)

	if valtype(w) == "U"
		w := 120
	endif
	if valtype(h) == "U"
		h := 140
	endif
	if valtype(value) == "U"
		value := 1
	endif
	if valtype(aFields) == "U"
		aFields := {}
		*October 13, 2009 
		IF VALTYPE( WorkArea ) = 'O'
			FOR p:= 0 TO WorkArea:Fields:Count - 1
				AADD( aFields, WorkArea:Fields(p):Name )
			NEXT
		ENDIF
	endif
	IF VALTYPE( aHeaders ) == 'U'
		aHeaders	:= {}
		FOR p := 0 TO WorkArea:Fields:Count - 1
			AADD( aHeaders, WorkArea:Fields(p):Name)
		NEXT
	ENDIF
	IF VALTYPE( aWidths ) == 'U'
		aWidths	:= {}
		FOR p:= 0 TO WorkArea:Fields:Count - 1
			AADD( aHeaders, 80 )
		NEXT
	ENDIF
		
	if valtype(aJust) == "U"		// Browse+		
		aJust := Array( len( aFields ) )
		aFill( aJust, 0 )		
		FOR r := 1 TO LEN( aFields )
			DO CASE
			CASE _AdoType(aFields[r], workarea ) = 'N'
				aJust[r] := 1
			CASE _AdoType(aFields[r], workarea ) = 'F'
				aJust[r] := 1
			CASE _AdoType(aFields[r], workarea ) = 'D'
				aJust[r] := 2
			ENDCASE
		NEXT r
	else
		aSize( aJust, len( aFields) )
		aEval( aJust, { |x| x := iif( x == NIL, 0, x ) } )
	endif
	
	if valtype(aImage) == "U"
		aImage := {}
	endif

	// If splitboxed force no vertical scrollbar
	
	if valtype(x) == "U" .or. valtype(y) == "U" 
		novscroll := .T.
	endif
		
	if novscroll == .F.
		DeltaWidth := GETVSCROLLBARWIDTH() 
	Else
		DeltaWidth := 0
	EndIf
	
	if valtype(x) == "U" .or. valtype(y) == "U" 
		If _HMG_SYSDATA [ 216 ] == 'TOOLBAR'
			Break := .T.
		EndIf
		_HMG_SYSDATA [ 216 ]	:= 'GRID'
		i := GetFormIndex ( cParentForm )
		if i > 0 
			ControlHandle := InitBrowse ( ParentForm, 0, x, y, w - DeltaWidth , h , '', 0, iif( nogrid, 0, 1 ) ) // Browse+	
			x := GetWindowCol ( Controlhandle )
			y := GetWindowRow ( Controlhandle )
			if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
				FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
			Else
				FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)		
			endif
			AddSplitBoxItem ( Controlhandle, _HMG_SYSDATA [ 87 ] [i] , w , break , , , , _HMG_SYSDATA [ 258 ] )
		EndIf
	Else
		ControlHandle := InitBrowse ( ParentForm, 0, x, y, w - DeltaWidth , h , '', 0, iif( nogrid, 0, 1 ) ) // Browse+	
		if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
			FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
		Else
			FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)		
		endif
	endif

	If ValType (backcolor) != 'U'
		ListView_SetBkColor ( ControlHandle , backcolor[1] , backcolor[2] , backcolor[3] )
		ListView_SetTextBkColor ( ControlHandle , backcolor[1] , backcolor[2] , backcolor[3]  )
	EndIf

	If ValType (fontcolor) != 'U'
		ListView_SetTextColor ( ControlHandle , fontcolor[1] , fontcolor[2] , fontcolor[3]  )
	EndIf

	wBitmap 	:= IIF( LEN( aImage ) > 0, AddListViewBitmap( ControlHandle, aImage ), 0 ) //Add Bitmap Column
	aWidths[1] 	:= MAX ( aWidths[1], wBitmap + 2 ) // Set Column 1 witth to Bitmap width

	if valtype(aHeadClick) == "U"
		aHeadClick := {}
	endif

	if valtype(change) == "U"
		change := ""
	endif

	if valtype(dblclick) == "U"
		dblclick := ""
	endif

	if valtype(tooltip) != "U"
		SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
	endif

	k 				:= _GetControlFree()
	PUBLIC &mVar. 	:= k

	_HMG_SYSDATA [  1 ] [k] := "BROWSEADO" 
	_HMG_SYSDATA [  2 ] [k] := ControlName 
	_HMG_SYSDATA [  3 ] [k] := ControlHandle 
	_HMG_SYSDATA [  4 ] [k] := ParentForm 
	_HMG_SYSDATA [  5 ] [k] := 0 
	_HMG_SYSDATA [  6 ] [k] := aWidths 
	_HMG_SYSDATA [  7 ] [k] := aHeaders
	_HMG_SYSDATA [  8 ] [k] := Value 
	_HMG_SYSDATA [  9 ] [k] := Lock 
	_HMG_SYSDATA [ 10 ] [k] := lostfocus 
	_HMG_SYSDATA [ 11 ] [k] := gotfocus 
	_HMG_SYSDATA [ 12 ] [k] := change 
	_HMG_SYSDATA [ 13 ] [k] := .F. 	
	_HMG_SYSDATA [ 14 ] [k] := aImage // Browse+
	_HMG_SYSDATA [ 15 ] [k] := inplace 
	_HMG_SYSDATA [ 16 ] [k] := dblclick 
	_HMG_SYSDATA [ 17 ] [k] := aHeadClick 
	_HMG_SYSDATA [ 18 ] [k] := y 
	_HMG_SYSDATA [ 19 ] [k] := x 
	_HMG_SYSDATA [ 20 ] [k] := w 
	_HMG_SYSDATA [ 21 ] [k] := h 
	_HMG_SYSDATA [ 22 ] [k] := WorkArea 
	_HMG_SYSDATA [ 23 ] [k] := iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 24 ] [k] := iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 25 ] [k] := IF( VALTYPE(Delete) =='L', Delete, .F. )
	_HMG_SYSDATA [ 26 ] [k] := 0 
	_HMG_SYSDATA [ 27 ] [k] := fontname 
	_HMG_SYSDATA [ 28 ] [k] := fontsize 
	_HMG_SYSDATA [ 29 ] [k] := {bold,italic,underline,strikeout} 
	_HMG_SYSDATA [ 30 ] [k] := tooltip  
	_HMG_SYSDATA [ 31 ] [k] := aFields  
	_HMG_SYSDATA [ 32 ] [k] := {}  
	_HMG_SYSDATA [ 33 ] [k] := aHeaders  
	_HMG_SYSDATA [ 34 ] [k] := .t. 
	_HMG_SYSDATA [ 35 ] [k] := HelpId 
	_HMG_SYSDATA [ 36 ] [k] := FontHandle 
	_HMG_SYSDATA [ 37 ] [k] := cParentTabName
	_HMG_SYSDATA [ 38 ] [k] := .T. 
	_HMG_SYSDATA [ 39 ] [k] := { 0 , appendable , readonly , valid , validmessages , edit , inputitems , displayitems , Nil , Nil , Nil }
	_HMG_SYSDATA [ 40 ] [k] := { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

	InitListViewColumns ( ControlHandle , aHeaders , aWidths, aJust ) // Browse+

	// Add to browselist array to update on window activation

	i := k
	AADD ( M->_HMG_SYSDATA [ 89 ]	[ GetFormIndex ( cParentForm ) ] , k )
	FOR z := 1 TO LEN ( _HMG_SYSDATA [ 6 ] [i] )
		hsum 						:= hsum + ListView_GetColumnWidth ( _HMG_SYSDATA [3] [i] , z - 1 )
		_HMG_SYSDATA [6] [i] [z] 	:= ListView_GetColumnWidth ( _HMG_SYSDATA [3] [i] , z - 1 )
	NEXT z

	// Add Vertical scrollbar 

	IF novscroll == .F.
		IF hsum > w - GETVSCROLLBARWIDTH() - 4
			ScrollBarHandle 		:= InitVScrollBar (  ParentForm , x + w - GETVSCROLLBARWIDTH() , y , GETVSCROLLBARWIDTH() , h - GETHSCROLLBARHEIGHT() )		
			ScrollBarButtonHandle 	:= InitVScrollBarButton (  ParentForm , x + w - GETVSCROLLBARWIDTH() , y + h - GETHSCROLLBARHEIGHT() , GETVSCROLLBARWIDTH() , GETHSCROLLBARHEIGHT() )		
		ELSE
			ScrollBarHandle 		:= InitVScrollBar (  ParentForm , x + w - GETVSCROLLBARWIDTH() , y , GETVSCROLLBARWIDTH() , h )		
			ScrollBarButtonHandle 	:= InitVScrollBarButton (  ParentForm , x + w - GETVSCROLLBARWIDTH() , y + h - GETHSCROLLBARHEIGHT() , 0 , 0 )					
		ENDIF
		IF _HMG_SYSDATA [ 265 ] = .T.
			AADD ( _HMG_SYSDATA [ 142 ] , { ControlHandle , ScrollBarHandle , ScrollBarButtonHandle } )
		ENDIF
	ELSE
		ScrollBarHandle := 0
		IF _HMG_SYSDATA [ 265 ] = .T.
			AADD ( _HMG_SYSDATA [ 142 ] , ControlHandle )
		ENDIF
	ENDIF

	_HMG_SYSDATA [  5 ] [k] 	:= ScrollBarHandle
	_HMG_SYSDATA [ 39 ] [k] [1] := ScrollBarButtonHandle
	_HMG_SYSDATA [ 40 ] [k] [1] := dynamicbackcolor
	_HMG_SYSDATA [ 40 ] [k] [2] := dynamicforecolor
	_HMG_SYSDATA [ 40 ] [k] [3] := aWhenFields
	_HMG_SYSDATA [ 40 ] [k] [4] := inputmask
	_HMG_SYSDATA [ 40 ] [k] [5] := format

	IF VALTYPE(aHeaderImages) <> "U"
		nHeaderImageListHandle 		:= SetListViewHeaderImages ( ControlHandle , aHeaderImages , aJust )
		_HMG_SYSDATA [ 39 ] [k] [ 9]:= aHeaderImages
		_HMG_SYSDATA [ 39 ] [k] [10]:= nHeaderImageListHandle
		_HMG_SYSDATA [ 39 ] [k] [11]:= aJust
	ENDIF
	
	_HMG_SYSDATA[63]:= .T.	

	IF WorkArea:RecordCount > 0 
		Value = IF( Value > 0, Value, 1)
	ENDIF
	WorkArea:Movefirst()
	_BrowseAdoUpdate('','',k)
		
	IF novscroll == .F.
		_BrowseAdoAdjustScroll(k)	
	ENDIF
RETURN 
*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoUpdate( ControlName,ParentName , z )
*-----------------------------------------------------------------------------*
	LOCAL PageLength , aTemp := {} , cTemp , Fields , _BrowseRecMap := {} , i , x , j , First , Image , _Rec , ColorMap , ColorRow , processdbc , processdfc , k
	LOCAL dbc
	LOCAL dFc 
	      
	LOCAL fcolormap
	LOCAL fcolorrow
	      
	LOCAL dim
	LOCAL processdim
	      
	LOCAL dft
	LOCAL processdft
	      
	LOCAL teval
	      
	LOCAL aDisplayItems
	LOCAL aDisplayItemsLengths
	LOCAL aProcessDisplayItems
	LOCAL lFound
	LOCAL p
	LOCAL _WorkArea, texto := ""

	IF PCOUNT() == 2
		i := GetControlIndex(ControlName,ParentName)
	ELSE
		i := z
	ENDIF
	*----
	aDisplayItems 		:= _HMG_SYSDATA [39] [I] [8]
	aProcessDisplayItems:= ARRAY ( LEN (_HMG_SYSDATA [ 31 ] [i]) )
	aDisplayItemsLengths:= ARRAY ( LEN (_HMG_SYSDATA [ 31 ] [i]) )
	*-October 13, 2009 
	_WorkArea			:= _HMG_SYSDATA[22][i]
	*---
	IF VALTYPE (aDisplayItems) = 'A' 
		FOR k := 1 TO LEN ( aProcessDisplayItems )
			IF VALTYPE ( aDisplayItems [k] ) = 'A'
				aProcessDisplayItems [k] := .T.
				aDisplayItemsLengths [k] := LEN ( aDisplayItems [k] )
			ELSE
				aProcessDisplayItems [k] := .F.
				aDisplayItemsLengths [k] := 0
			ENDIF
		NEXT k
	ELSE
		FOR k := 1 TO LEN ( aProcessDisplayItems )
			aProcessDisplayItems [k] := .F.
			aDisplayItemsLengths [k] := 0
		NEXT k
	ENDIF
	*
	dim 		:= _HMG_SYSDATA [40] [I] [4]
	processdim 	:= ARRAY ( LEN (_HMG_SYSDATA [ 31 ] [i]) )

	IF VALTYPE (dim) = 'A' 
		FOR k := 1 TO LEN ( processdim )
			IF VALTYPE ( dim [k] ) = 'C'
				IF .NOT. EMPTY ( dim [k] )
					processdim [k] := .T.
				ELSE
					processdim [k] := .F.
				ENDIF
			ELSE
				processdim [k] := .F.
			ENDIF
		NEXT k
	ELSE
		FOR k := 1 TO LEN ( processdim )
			processdim [k] := .F.
		NEXT k
	ENDIF

	dft 		:= 	_HMG_SYSDATA [40] [I] [5]
	processdft 	:= ARRAY ( LEN (_HMG_SYSDATA [ 31 ] [i]) )

	IF VALTYPE (dft) = 'A' 

		FOR k := 1 TO LEN ( processdft )
			IF VALTYPE ( dft [k] ) = 'C'
				IF .NOT. EMPTY ( dft [k] )
					processdft [k] := .T.
				ELSE
					processdft [k] := .F.
				ENDIF
			ELSE
				processdft [k] := .F.
			ENDIF
		NEXT k
	ELSE
		FOR k := 1 TO LEN ( processdft )
			processdft [k] := .F.
		NEXT k
	ENDIF
	
	dbc 					:= _HMG_SYSDATA [ 40 ] [i] [1]
	processdbc 				:= IF(VALTYPE(dbc) = 'A' , .t. , .f. )
	dfc 					:= _HMG_SYSDATA [ 40 ] [i] [2]
	processdFc 				:= IF(VALTYPE(dFc) = 'A' , .t. , .f. )
	_HMG_SYSDATA [ 26 ] [i] := 0
	First   				:= IIF( LEN( _HMG_SYSDATA [ 14 ][i] ) == 0, 1, 2 ) // Browse+ ( 2= bitmap definido, se cargan campos a partir de 2 )
	Fields 					:= _HMG_SYSDATA [ 31 ] [i]
	
	ListViewReset ( _HMG_SYSDATA [3][i] )
	PageLength 				:= ListViewGetCountPerPage ( _HMG_SYSDATA [3][i] ) 


	IF processdbc == .t.
		colormap := {}
		colorrow := {}
	ENDIF

	IF processdfc == .t.
		fcolormap := {}
		fcolorrow := {}
	ENDIF

	FOR x := 1 TO PageLength
		aTemp := {}
		IF First == 2						// Browse+
			cTemp := Fields [1]		
			IF _AdoType (cTemp) == 'N'				// ..
				image := _Workarea:fields(cTemp):Value			
			ELSEIF _AdoType (cTemp) == 'L'			// ..
				image := iif( _WorkArea:Fields(cTemp):Value, 1, 0 )		
			ELSE						// ..
				image := 0	
			ENDIF						// ..
			AADD ( aTemp , NIL )
			IF processdbc == .t.
				IF VALTYPE ( dbc ) = 'A'
					IF LEN ( dbc ) = LEN ( Fields ) 
						AADD( colorrow , -1 )
					ENDIF       
				ENDIF        
			ENDIF
			IF processdfc == .t.
				IF VALTYPE ( dfc ) = 'A'
					IF LEN ( dfc ) = LEN ( Fields ) 
						AADD ( fcolorrow , -1 )
					ENDIF
				ENDIF
			ENDIF
		ENDIF							// Browse+

		FOR j := First TO LEN (Fields)
			cTemp := Fields [j]
			IF aProcessDisplayItems [ j ] == .T.
				lFound := .F. 
				IF _WorkArea:AbsolutePosition > 0 /*eof() .and. !_WorkArea:bof()*/
					FOR p := 1 TO aDisplayItemsLengths [ j ] 
						IF VALTYPE(aDisplayItems [ j ] [ p ] [ 2 ]) = _AdoType(_WorkArea:Fields(cTemp):Name, _WorkArea)
							IF aDisplayItems [ j ] [ p ] [ 2 ] = _WorkArea:Fields(cTemp):Value
								AADD ( aTemp , RTRIM ( aDisplayItems [ j ] [ p ] [ 1 ] ) )
								lFound := .T. 
								EXIT
							ENDIF
						ENDIF
					NEXT p
					IF lFound == .F.
						AADD ( aTemp , '' )
					ENDIF
				ENDIF
			ELSE
				IF _WorkArea:AbsolutePosition > 0  /*!_WorkArea:Bof() .and. ! _WorkArea:eof()*/
					IF _WorkArea:Fields(cTemp):ActualSize = 0
						If _AdoType (cTemp,i) == 'C'
							AADD( aTemp, "")
						ElseIf _AdoType (cTemp,i) == 'D'
							AADD( aTemp, '  /  /    ')
						ElseIf _AdoType (cTemp,i) == 'L'
							AADD( aTemp, '.T.')
						ElseIf _AdoType (cTemp,i) == 'M'
							AADD( aTemp, "")
						ElseIf _AdoType (cTemp,i) == 'N'
							AADD( aTemp, "0")
						Elseif _AdoType(cTemp,i) == 'F'
							AADD( aTemp, "0.000")
						ENDIF
					ELSE
						IF VALTYPE(_HMG_SYSDATA[40][i][4]) == 'A'
							IF VALTYPE( _HMG_SYSDATA[40][I][4][j] ) == 'C'
								AADD( aTemp, TRANSFORM( _WorkArea:fields(cTemp):Value, _HMG_SYSDATA[40][I][4][J] ) )
							ELSE
								AADD( aTemp, HB_VALTOSTR( _WorkArea:fields(cTemp):Value) )
							ENDIF
						ELSE
							AADD( aTemp, HB_VALTOSTR( _WorkArea:fields(cTemp):Value) )
						ENDIF						
					ENDIF
				ENDIF
			ENDIF
			
			IF processdbc == .t.
				IF VALTYPE ( dbc ) = 'A'
					IF LEN ( dbc ) = LEN ( Fields ) 
						IF VALTYPE ( dbc [j] ) = 'B'
							tEval := EVAL ( dbc [j] )
							IF VALTYPE ( TEVAL ) == 'A'
								IF LEN ( TEVAL ) == 3									
									TEVAL := RGB ( TEVAL [1] , TEVAL [2] , TEVAL [3] )																	
								ENDIF
							ENDIF
							AADD ( colorrow , tEval )
						ELSE
							AADD ( colorrow , -1 )
						ENDIF
					ENDIF
				ENDIF
			ENDIF
			IF processdfc == .t.
				IF VALTYPE ( dfc ) = 'A'
					IF LEN ( dfc ) = LEN ( Fields ) 
						IF VALTYPE ( dfc [j] ) = 'B'
							tEval := EVAL ( dfc [j] )
							IF VALTYPE ( TEVAL ) == 'A'
								IF LEN ( TEVAL ) == 3
									TEVAL := RGB ( TEVAL [1] , TEVAL [2] , TEVAL [3] )
								ENDIF
							ENDIF
							AADD ( fcolorrow , tEval )
						ELSE
							AADD ( fcolorrow , -1 )
						ENDIF
					ENDIF
				ENDIF
			ENDIF
		NEXT J

		AddListViewItems ( _HMG_SYSDATA [3][i] , aTemp , Image )

		*-_Rec := RecNo()
		*- October 13, 2009 
		AADD ( _BrowseRecMap , _WorkArea:AbsolutePosition ) 

		IF processdbc == .t.
			AADD ( colormap , colorrow )
			colorrow := {}
		ENDIF

		IF processdfc == .t.
			AADD ( fcolormap , fcolorrow )
			fcolorrow := {}
		ENDIF
		IF _WorkArea:AbsolutePosition > 0 
			_WorkArea:MoveNext()
		ENDIF
		IF _WorkArea:Eof()
			_HMG_SYSDATA [ 26 ] [i] := 1
			IF _WorkArea:RecordCount > 0
				_WorkArea:Movelast()
			ENDIF
			EXIT
		ENDIF
	NEXT x

	_HMG_SYSDATA [ 40 ] [ I ] [ 6 ] := IF( processdbc == .t., colormap, NIL )	
	_HMG_SYSDATA [ 40 ] [ I ] [ 7 ] := IF( processdfc == .t., fcolormap, NIL )
	_HMG_SYSDATA [ 32 ] [i] 		:= _BrowseRecMap

RETURN

FUNCTION _AdoType ( cTemp, p )
	*-October 13, 2009 
	LOCAL Rs	:=NIL
	LOCAL cType	:= ""
	IF VALTYPE(p) = 'N'
		Rs:= _HMG_SYSDATA[22][p]  
	ELSEIF VALTYPE(p) = 'O'
		Rs:= p
	ENDIF
	IF 		rs:Fields(cTemp):Type = adDate
		cType	= 'D'
	ELSEIF  rs:fields(cTemp):Type = adInteger
		cType = 'N'
	ELSEIF  rs:fields(cTemp):Type = adSingle
		cType = 'N'
	ELSEIF  rs:fields(cTemp):Type = adDouble
		cType = 'F'
	ELSEIF  rs:fields(cTemp):Type = adCurrency
		cType = 'F'
	ELSEIF  rs:Fields(cTemp):Type = adDecimal
		cType = 'F'
	ELSEIF 	rs:fields(cTemp):Type = adBoolean
		cType	= 'L'
	ELSEIF 	rs:fields(cTemp):Type = adChar 
		cType	= 'C'
	ELSEIF 	rs:fields(cTemp):Type = adWChar 
		cType	= 'C'
	ELSEIF 	rs:fields(cTemp):Type = adLongVarWChar 
		cType	= 'M'
	ELSEIF  rs:fields(cTemp):Type = adVarWChar
		cType	= 'C'		
	ELSE
		cType	= NIL
	ENDIF
RETURN cType

*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoNext ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
	LOCAL i , PageLength , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil } , s 
	*- AV PAG
	i 				:= IF( PCOUNT() == 2, GetControlIndex ( ControlName , ParentForm ), z )
	_DeltaScroll 	:= ListView_GetSubItemRect ( _HMG_SYSDATA [3][i] , 0 , 0 ) 
	_BrowseRecMap 	:= _HMG_SYSDATA [ 32 ] [i] 
	PageLength 		:= LISTVIEWGETCOUNTPERPAGE ( _HMG_SYSDATA [3][i] ) 
	s 				:= LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] )

	IF  s == PageLength 
		if _HMG_SYSDATA [ 26 ] [i] != 0
			Return
		EndIf
		*-October 13, 2009 
		_BrowseArea := _HMG_SYSDATA [ 22 ] [i]
		IF _BrowseArea:RecordCount > 0
			_BrowseArea:MoveNext()
			IF _BrowseArea:eof()
				_BrowseArea:Movelast()
			ENDIF
			_RecNo 		:= _BrowseArea:AbsolutePosition
			_BrowseAdoUpdate( ControlName , ParentForm , i )
			_BrowseAdoVscrollUpdate( i )
			ListView_Scroll( _HMG_SYSDATA [3][i] , _DeltaScroll[2] * (-1) , 0 )
			ListView_SetCursel ( _HMG_SYSDATA [3] [i] , LEN(_HMG_SYSDATA [ 32 ] [i] ) )
			_BrowseArea:Move( _RecNo )
		ENDIF
	ELSE
		ListView_SetCursel ( _HMG_SYSDATA [3] [i] , LEN(_BrowseRecMap) )
		_BrowseAdoVscrollFastUpdate ( i , PageLength - s )
	ENDIF
	_BrowseAdoOnChange (i)
RETURN
*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoPrior ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
	LOCAL i , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }

	I 				:= IF( PCOUNT() == 2, GetControlIndex ( ControlName , ParentForm ), z)
	_DeltaScroll 	:= ListView_GetSubItemRect ( _HMG_SYSDATA [3][i] , 0 , 0 ) 
	_BrowseRecMap	:= _HMG_SYSDATA [ 32 ] [i] 
	_BrowseArea 	:= _HMG_SYSDATA [ 22 ] [i]

	IF LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) == 1
		IF _BrowseArea:Recordcount > 0 .AND. ! _BrowseArea:Bof()
			_RecNo := _BrowseAdoGetValue("", "", i ) /*BrowseArea:AbsolutePosition*/
      		IF _Recno - LISTVIEWGETCOUNTPERPAGE (  _HMG_SYSDATA [3][i] ) + 1 < 1
      			_Browsearea:MoveFirst()
      			_Browsearea:AbsolutePosition := 1
      		ELSE
      			_BrowseArea:Move( - LISTVIEWGETCOUNTPERPAGE (  _HMG_SYSDATA [3][i] ) + 1 )
      		ENDIF			
			_BrowseAdoVscrollUpdate( i )
			_BrowseAdoUpdate(ControlName , ParentForm , i )
			ListView_Scroll( _HMG_SYSDATA [3][i] , _DeltaScroll[2] * (-1) , 0 )
			_BrowseArea:Move( _RecNo )
		ENDIF
	ELSE
		_BrowseAdoVscrollFastUpdate ( i , 1 - LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) )
	ENDIF
	ListView_SetCursel ( _HMG_SYSDATA [3] [i] , 1 )		
	_BrowseAdoOnChange (i)
RETURN
*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoHome ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
	LOCAL i , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }
	i 				:= If( pcount() == 2, GetControlIndex ( ControlName , ParentForm ), Z )
	_DeltaScroll 	:= ListView_GetSubItemRect ( _HMG_SYSDATA [3][i] , 0 , 0 ) 
	_BrowseRecMap 	:= _HMG_SYSDATA [ 32 ] [i] 
	_BrowseArea 	:= _HMG_SYSDATA [ 22 ] [i]
	IF _BrowseArea:Recordcount > 0		
		_BrowseArea:Movefirst()
		IF _BrowseArea:bof()
			_BrowseArea:Movefirst()
		ENDIF
		_RecNo := _BrowseArea:AbsolutePosition
		_BrowseAdoVscrollUpdate(i)
		_BrowseAdoUpdate( ControlName , ParentForm , i )
		ListView_Scroll( _HMG_SYSDATA [3][i] , _DeltaScroll[2] * (-1) , 0 )
		_BrowseArea:AbsolutePosition := _RecNo
		ListView_SetCursel ( _HMG_SYSDATA [3] [i] , 1 )		
	ENDIF
	_BrowseAdoOnChange (i)
RETURN
*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoEnd ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
	LOCAL i , _Alias , _RecNo , _BrowseArea , _BrowseRecMap   , _DeltaScroll := { Nil , Nil , Nil , Nil } , _BottomRec
	i 				:= IF( PCOUNT() == 2, GetControlIndex ( ControlName , ParentForm ), z )
	_DeltaScroll 	:= ListView_GetSubItemRect ( _HMG_SYSDATA [3][i] , 0 , 0 ) 
	_BrowseRecMap 	:= _HMG_SYSDATA [ 32 ] [i] 
	_BrowseArea 	:= _HMG_SYSDATA [ 22 ] [i]
	IF _BrowseArea:RecordCount > 0
		_BottomRec := _BrowseArea:RecordCount
		_BrowseAdoVscrollUpdate( i )
		IF ( LISTVIEWGETCOUNTPERPAGE ( _HMG_SYSDATA[3][I] ) - 2 ) > _BrowseArea:Recordcount
			_BrowseArea:MoveFirst()
			_Recno	= 1
		ELSE
			_Recno:= ( LISTVIEWGETCOUNTPERPAGE (_HMG_SYSDATA[3][I] ) - 2)
			IF _Recno < 1
				_Recno	:= 1
			ENDIF
		ENDIF
		_BrowseArea:AbsolutePosition := _BottomRec - _Recno 
		_BrowseAdoUpdate('', '', i )		
		_BrowseArea:MoveLast()
		ListView_Scroll( _HMG_SYSDATA [3][i] , _DeltaScroll[2] * (-1) , 0 )
		ListView_SetCursel ( _HMG_SYSDATA [3] [i] , ASCAN ( _HMG_SYSDATA [ 32 ] [i] , _BottomRec ) )
		_BrowseAdoVscrollUpdate( i )
	ENDIF
	_BrowseAdoOnChange (i)
RETURN
*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoUp ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
	LOCAL i , s  , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }
	
	i 				:= IF( PCOUNT() == 2, GetControlIndex ( ControlName , ParentForm ), Z )
	_DeltaScroll 	:= ListView_GetSubItemRect ( _HMG_SYSDATA [3][i] , 0 , 0 ) 
	_BrowseRecMap	:= _HMG_SYSDATA [ 32 ] [i] 
	s 				:= LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) 
	_BrowseArea 	:= _HMG_SYSDATA [ 22 ] [i]

	IF s == 1
		IF _BrowseArea:RecordCount > 0
			_RecNo := _BrowseArea:AbsolutePosition			
			IF _BrowseRecMap[1] > 0 .AND. _BrowseRecMap[1] <=_BrowseArea:RecordCount
				_BrowseArea:AbsolutePosition := _BrowseRecMap [1] 
			ELSE
				_BrowseArea:AbsolutePosition := IF( _BrowseArea:Bof(), 1, _BrowseArea:RecordCount )
			ENDIF
			_BrowseArea:MovePrevious()
			IF _BrowseArea:Bof()
				_BrowseArea:Movefirst()
			ENDIF
			_BrowseAdoVscrollUpdate( i )
			_BrowseAdoUpdate(ControlName , ParentForm , i )
			ListView_Scroll( _HMG_SYSDATA [3][i] , _DeltaScroll[2] * (-1) , 0 )
			_BrowseArea:AbsolutePosition := _RecNo
			ListView_SetCursel ( _HMG_SYSDATA [3] [i] , 1 )		
		ENDIF
	ELSE
		ListView_SetCursel ( _HMG_SYSDATA [3] [i] , s - 1 )		
		_BrowseAdoVscrollFastUpdate ( i , -1 )
	ENDIF
	_BrowseAdoOnChange (i)
RETURN
*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoDown ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
	LOCAL i , PageLength , s , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }

	I 				:= IF( PCOUNT() == 2, GetControlIndex ( ControlName , ParentForm ), z )
	_DeltaScroll 	:= ListView_GetSubItemRect ( _HMG_SYSDATA [3][i] , 0 , 0 ) 
	_BrowseRecMap 	:= _HMG_SYSDATA [ 32 ] [i] 
	s 				:= LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) 
	PageLength 		:= LISTVIEWGETCOUNTPERPAGE ( _HMG_SYSDATA [3][i] ) 
	_BrowseArea 	:= _HMG_SYSDATA [ 22 ] [i]

	IF s == PageLength
		IF _BrowseArea:Recordcount > 0
			_RecNo := _BrowseArea:AbsolutePosition			
			_BrowseArea:MoveNext()
			IF _BrowseArea:eof()
				*- SI LOCK = .T. ESTA BLOQUEADO PARA EDICION.
				IF _HMG_SYSDATA[9][I] == .F.
					* ACTUALIZO LA LISTA PARA QUE EN CASO QUE EST EN LA ULTIMA LINEA
					* SUBA LOS REGISTROS Y DEJE UNA LINEA VACIA PARA EDITAR.
					_BrowseArea:AbsolutePosition := _Recno - (s-2)
					_BrowseAdoUpdate( ControlName , ParentForm , i )
					ListView_Scroll( _HMG_SYSDATA [3][i] , _DeltaScroll[2] * (-1) , 0 )
					_BrowseArea:AbsolutePosition := _RecNo
					ListView_SetCursel ( _HMG_SYSDATA [3] [i] , Len(_HMG_SYSDATA [ 32 ] [i]) )											
					_HMG_SYSDATA [ 39 ] [i] [2] := .T.
					AdoProcessInPlaceKbdEdit(i)      
					* ESTE RETURN EVITA QUE SE VUELVA A EVALUAR Y REPOSICIONAR EL BROWSE.
					RETURN
				ELSE
					_BrowseArea:Movelast()					
					*ESTE RETURN EVITA TAMBIEN QUE SE VUELVA A REPOSICIONAR SI YA ESTA EN EOF.
					RETURN
				ENDIF			
			ELSE
				_RecNo 						:= _BrowseArea:AbsolutePosition
				_BrowseArea:AbsolutePosition:= _Recno - (s-2)
			ENDIF
			_Recno = _BrowseArea:AbsolutePosition
			_BrowseAdoUpdate( ControlName , ParentForm , i )
			_BrowseAdoVscrollUpdate( i )
			ListView_Scroll( _HMG_SYSDATA [3][i] , _DeltaScroll[2] * (-1) , 0 )
			_BrowseArea:AbsolutePosition := _RecNo
			ListView_SetCursel ( _HMG_SYSDATA [3] [i] , Len(_HMG_SYSDATA [ 32 ] [i]) )		
		ENDIF
	ELSE
		IF _BrowseArea:RecordCount > 0 
			_BrowseArea:MoveNext()
			IF _BrowseArea:eof()				
				*-IF _HMG_SYSDATA[39][I][6] == .T.
				IF _HMG_SYSDATA [9] [i] == .F. 
					_HMG_SYSDATA [ 39 ] [i] [2] := .T.
					AdoProcessInPlaceKbdEdit(i)      
				ELSE
					_BrowseArea:Movelast()
				ENDIF					
			ENDIF
		ENDIF		
		ListView_SetCursel ( _HMG_SYSDATA [3] [i] , s+1 )		
		_BrowseAdoVscrollFastUpdate ( i , 1 )
	ENDIF
	_BrowseAdoOnChange (i)
RETURN
*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoRefresh ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
	LOCAL i , s , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }
	LOCAL v, n
	*MEMVAR cMacroVar
	PRIVATE cMacroVar

	i 				:= If( pcount() == 2, GetControlIndex ( ControlName , ParentForm ), z )	
	v 				:= _BrowseAdoGetValue ( '','' , i )
	_DeltaScroll 	:= ListView_GetSubItemRect ( _HMG_SYSDATA [3][i] , 0 , 0 ) 
	_BrowseRecMap 	:= _HMG_SYSDATA [ 32 ] [i] 
	s 				:= LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) 
	_BrowseArea 	:= _HMG_SYSDATA [ 22 ] [i]
	_RecNo 			:= _BrowseArea:AbsolutePosition

	if v <= 0 .OR. v <> _Recno
		IF _BrowseArea:RecordCount > 0
			DO CASE
			CASE _BrowseArea:AbsolutePosition = ADPOSBOF
				_Recno 	= 1
			CASE _BrowseArea:AbsolutePosition = ADPOSEOF
				_Recno	= _BrowseArea:RecordCount
			CASE _BrowseArea:AbsolutePosition = ADPOSUNKNOWN
				_Recno = 1
			ENDCASE
		ENDIF
		v := _RecNo
	EndIf
		                  	
	IF v < 1
		IF _BrowseArea:Recordcount > 0
			v 		= 1
			DO CASE
			CASE _BrowseArea:AbsolutePosition = ADPOSBOF
				_Recno 	= 1
			CASE _BrowseArea:AbsolutePosition = ADPOSEOF
				_Recno	= _BrowseArea:RecordCount
			CASE _BrowseArea:AbsolutePosition = ADPOSUNKNOWN
				_Recno = 1
			ENDCASE
		ELSE
			ListViewReset ( _HMG_SYSDATA [3][i] )
			RETURN			
		ENDIF
	ENDIF
	
	IF s != 0		
   		IF _HMG_SYSDATA[39][i][2] == .T.	
   			*- Si se estaba mostrando el control para edicion y se presion escape.
   			n := s-2
      		FOR l:=1 TO n
      			*-October 05, 2009  se cae si es bof
      			IF ! _BrowseArea:bof()      				
      				_BrowseArea:MovePrevious()      	
      			ENDIF
    		NEXT      
    	ELSE
      		FOR l:=1 TO s-1
      			*-October 05, 2009  se cae si es bof
      			IF !_BrowseArea:bof() .and. ! _BrowseArea:eof()
      				_BrowseArea:MovePrevious()      	
      			ENDIF
    		NEXT      
    	ENDIF    	
	ENDIF
	_BrowseAdoUpdate( '' , '' , i )
	_BrowseAdoVscrollUpdate( i )	
	ListView_Scroll( _HMG_SYSDATA [3][i] , _DeltaScroll[2] * (-1) , 0 )
	ListView_SetCursel ( _HMG_SYSDATA [3] [i] , ASCAN ( _HMG_SYSDATA [ 32 ] [i] , v ) )		
	_BrowseAdoOnChange (i)	
	IF _BrowseArea:RecordCount > 0
		_BrowseArea:AbsolutePosition := _RecNo 
	ENDIF
	_BrowseArea:AbsolutePosition := v
	_BrowseAdoAdjustScroll(i)	
RETURN
*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoSetValue ( ControlName , ParentForm , Value , z , mp )
*-----------------------------------------------------------------------------*
	LOCAL i  , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , NewPos := 50  , _DeltaScroll := { Nil , Nil , Nil , Nil } , m
	PRIVATE cMacroVar

	IF VALTYPE(Value) = 'N'
		IF Value <= 0 
			RETURN
		ENDIF
	ENDIF
	
	i :=IF( VALTYPE ( z ) == 'U', GetControlIndex ( ControlName , ParentForm ), z )

	IF _HMG_SYSDATA [ 232 ] == 'BROWSE_ONCHANGE'
		IF i == _HMG_SYSDATA [ 203 ]
			MsgMiniGuiError ("BROWSE: Value property can't be changed inside ONCHANGE event. Program Terminated" )
		ENDIF
	ENDIF

	_BrowseArea := _HMG_SYSDATA [ 22 ] [i]

	IF Value > _BrowseArea:RecordCount .or. Value < 1
		RETURN
	ENDIF
	
	m 							:= IF( VALTYPE ( mp ) == 'U', INT ( ListViewGetCountPerPage ( _HMG_SYSDATA [3][i] ) / 2 ), mp )
	_DeltaScroll 				:= ListView_GetSubItemRect ( _HMG_SYSDATA [3][i] , 0 , 0 ) 
	_BrowseRecMap 				:= _HMG_SYSDATA [ 32 ] [i] 
	_RecNo 						:= _BrowseArea:AbsolutePosition
	_BrowseArea:AbsolutePosition:= Value

	IF _BrowseArea:Eof()
		RETURN
	ELSE
		IF PCOUNT() < 5
			_BrowseAdoVscrollUpdate( i )
		ENDIF
		_BrowseArea:Move( (-m+1) )
		IF _BrowseArea:Absoluteposition < 1 
			_BrowseArea:AbsolutePosition := 1
		ELSEIF _BrowseArea:Absoluteposition > _BrowseArea:Recordcount
			_BrowseArea:AbsolutePosition := _BrowseArea:Recordcount
		ENDIF			
	ENDIF
	_HMG_SYSDATA [8] [i] := Value
	IF Value == 1
		_BrowseAdoHome('','',i)
	ELSE
		_BrowseAdoUpdate( '' , '' , i )
	ENDIF
	IF _Recno > 0 .AND. _Recno <= _BrowseArea:Recordcount
		_BrowseArea:AbsolutePosition := _RecNo
	ELSE
		IF _BrowseArea:eof()
			_BrowseArea:MoveLast()
		ELSEIF _BrowseArea:bof()
			_BrowseArea:MoveFirst()
		ENDIF
	ENDIF
	ListView_Scroll( _HMG_SYSDATA [3][i] , _DeltaScroll[2] * (-1) , 0 )
	ListView_SetCursel ( _HMG_SYSDATA [3] [i] , ascan ( _HMG_SYSDATA [ 32 ] [i] , Value ) )		
	_HMG_SYSDATA [ 232 ] := 'BROWSE_ONCHANGE'
	_BrowseAdoOnChange (i)
	_HMG_SYSDATA [ 232 ] := ''
RETURN
*-----------------------------------------------------------------------------*
FUNCTION _BrowseAdoGetValue ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
	Local i , RetVal , _BrowseRecMap , _Alias , _BrowseArea

	i 				:= If( pcount() == 2, GetControlIndex ( ControlName , ParentForm ), z )	
	_BrowseArea 	:= _HMG_SYSDATA [ 22 ] [i]
	_BrowseRecMap 	:= _HMG_SYSDATA [ 32 ] [i] 
	IF LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) != 0
		RetVal 		:= _BrowseRecMap [ LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) ]
	ELSE       		
		RetVal 		:= 0
	ENDIF
RETURN ( RetVal )

*-----------------------------------------------------------------------------*
FUNCTION  _BrowseAdoDelete (  ControlName , ParentForm , z  )
*-----------------------------------------------------------------------------*
	LOCAL i , _BrowseRecMap , Value , _Alias , _RecNo , _BrowseArea 

	i := IF( PCOUNT() == 2, GetControlIndex ( ControlName , ParentForm ), z )

	IF _HMG_SYSDATA[9][I] == .T.
		RETURN NIL
	ENDIF
	
	IF LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) == 0
		RETURN Nil
	ENDIF

	_BrowseRecMap 	:=_HMG_SYSDATA [ 32 ] [i] 
	Value 			:=_BrowseRecMap [ LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) ]

	IF Value == 0
		RETURN Nil
	ENDIF
	
	_BrowseArea 				:= _HMG_SYSDATA [ 22 ] [i]
	_RecNo 						:= _BrowseArea:AbsolutePosition
	_BrowseArea:AbsolutePosition:= Value

	_BrowseArea:Delete()
	_BrowseArea:Update()
	_BrowseArea:MoveNext()
	IF _BrowseArea:eof()
		_BrowseArea:Movelast()
	ENDIF
	_BrowseAdoRefresh('','',i)
RETURN Nil
*------------------------------------------------------------------------------*
FUNCTION _BrowseAdoEdit ( GridHandle , aValid , aValidMessages , aReadOnly , lock , append , inplace , INPUTITEMS )
*------------------------------------------------------------------------------*
LOCAL a,l,g,actpos:={0,0,0,0},h,GRow,GCol,GWidth,Col,IRow, i , ControlName , j , FormName , item
LOCAL Title , aLabels , aInitValues := {} , aFormats := {} , aResults , z , tvar , BackRec , aStru , y , svar , q , BackArea , BrowseArea , TmpNames := {} , NewRec := 0 , MixedFields := .f.
LOCAL aInputMask
LOCAL aFormat
PRIVATE aWhen
PRIVATE aWhenVarNames

	InPlace := .T.
	*If InPlace
	_BrowseAdoInPlaceEdit ( GridHandle , aValid , aValidMessages , aReadOnly , lock , append , INPUTITEMS )
	RETURN Nil
	*EndIf

RETURN Nil

*------------------------------------------------------------------------------*
FUNCTION _BrowseAdoInPlaceEdit ( GridHandle , aValid , aValidMessages , aReadOnly , lock , append , aInputItems )
*------------------------------------------------------------------------------*
	LOCAL GridCol , GridRow , i , nrec , _GridWorkArea , BackArea , BackRec , _GridFields , FieldName , CellData  := '' , CellColIndex , x
	LOCAL aFieldNames
	LOCAL aTypes
	LOCAL aWidths
	LOCAL aDecimals
	LOCAL Type
	LOCAL Width
	LOCAL Decimals
	LOCAL sFieldname
	LOCAL r
	LOCAL ControlType
	LOCAL Ldelta := 0
	LOCAL aTemp
	LOCAL E
	LOCAL aInputMask
	LOCAL aFormat
	LOCAL BFN
	LOCAL BFS
	LOCAL lInputItems := .F.
	LOCAL aItems := {}
	LOCAL p
	LOCAL aValues := {}
	LOCAL ii
	
	IF ISWINDOWDEFINED(_InPlaceEdit)
		RETURN NIL
	ENDIF
	
	IF This.CellRowIndex != LISTVIEW_GETFIRSTITEM ( GridHandle )
		RETURN Nil
	ENDIF

	I 				:= ASCAN ( _HMG_SYSDATA [3] , GridHandle )
	BFN 			:= _HMG_SYSDATA [ 27 ] [i]
	BFS 			:= _HMG_SYSDATA [ 28 ] [i]
	aInputMask 		:= _HMG_SYSDATA [ 40 ] [ I ] [ 4 ]
	aFormat 		:= _HMG_SYSDATA [40] [I] [5]
	_GridWorkArea 	:= _HMG_SYSDATA [ 22 ] [i]
	_GridFields 	:= _HMG_SYSDATA [ 31 ] [i]
	CellColIndex 	:= This.CellColIndex

	IF CellColIndex < 1 .or. CellColIndex > Len (_GridFields)
		RETURN Nil
	ENDIF

	IF LEN ( _HMG_SYSDATA [ 14 ] [i] ) > 0 .AND. CellColIndex == 1
		PlayHand()
		RETURN Nil
	ENDIF

	IF VALTYPE ( aInputItems ) == 'A'
		IF LEN ( aInputItems ) >= CellColIndex
			IF VALTYPE ( aInputItems [ CellColIndex ] ) == 'A'
				         lInputItems := .T.				
			ENDIF
		ENDIF
	ENDIF

	IF VALTYPE ( aReadOnly ) == 'A'
		IF LEN ( aReadOnly ) >= CellColIndex
			IF aReadOnly [ CellColIndex ] != Nil
				IF aReadOnly [ CellColIndex ] == .T.
					_HMG_SYSDATA [ 256 ] := .F.
					RETURN Nil
				ENDIF
			ENDIF
		ENDIF
	ENDIF

	FieldName 	:=_GridFields [  CellColIndex ]
	BackRec 	:=_GridWorkArea:AbsolutePosition
	nRec 		:=_GetValue ( '','',i )
	IF nRec > 0 .and. nRec <= _GridWorkArea:RecordCount
		_GridWorkArea:AbsolutePosition 	:=  nRec
	ENDIF

	aTemp := _HMG_SYSDATA [40] [i] [3]

	IF VALTYPE ( aTemp ) = 'A'
		IF LEN (aTemp) == LEN (_GridFields)
			IF VALTYPE ( aTemp [CellColIndex] ) = 'B'
				E := EVAL ( aTemp [CellColIndex] )
				IF E == .F.
					PlayHand()
					// Restore Original Record Pointer
					_GridWorkArea:AbsolutePosition := BackRec
					// Restore Original WorkArea
					_HMG_SYSDATA [ 256 ] := .F.
					Return Nil
				ENDIF
			ENDIF
		ENDIF
	ENDIF
	IF _HMG_SYSDATA [ 39 ] [i] [2] == .T. .OR. _HMG_SYSDATA[22][I]:Eof()
		_HMG_SYSDATA [ 39 ] [i] [2] := .T.
		IF _AdoType (FieldName,i) == 'C'
			Celldata	= ""
		ELSEIF _AdoType (FieldName,i) == 'D'
			Celldata	= DATE()
		ElseIf _AdoType (FieldName,i) == 'L'
			Celldata := .T.
		ELSEIF _AdoType (FieldName,i) == 'M'
			Celldata := ""
		ELSEIF _AdoType (FieldName,i) == 'N'
			Celldata := 0
		ELSEIF _AdoType(Fieldname,i) == 'F'
			Celldata := 0.000
		ENDIF
	ELSE
		IF _GridWorkArea:Fields(FieldName):ActualSize = 0
			IF _AdoType (FieldName,i) == 'C'
				Celldata	= ""
			ELSEIF _AdoType (FieldName,i) == 'D'
				Celldata	= DATE()
			ELSEIF _AdoType (FieldName,i) == 'L'
				Celldata := .T.
			ELSEIF _AdoType (FieldName,i) == 'M'
				Celldata := ""
			ELSEIF _AdoType (FieldName,i) == 'N'
				Celldata := 0
			ELSEIF _AdoType(Fieldname,i) == 'F'
				Celldata := 0.000
			ENDIF
		ELSE				
			CellData 	:= _GridWorkArea:Fields(FieldName):Value 
		ENDIF
	ENDIF
    aFieldNames	:= ARRAY(_GridWorkarea:fields:Count)
   	aTypes		:= ARRAY(_GridWorkArea:Fields:Count)
    aWidths		:= ARRAY(_GridWorkArea:Fields:Count)
    aDecimals	:= ARRAY(_GridWorkArea:Fields:Count)

	AFIELDS(aFieldNames, aTypes, aWidths, aDecimals)
	
	sFieldName 	:= FieldName
	x 			:= _FieldPos ( sFieldName, i )
	GridRow 	:= GetWIndowRow (GridHandle)
	GridCol 	:= GetWIndowCol (GridHandle)

	IF lInputItems == .T.
		ControlType := 'X'
		Ldelta := 1
	ELSEIF _AdoType (FieldName,i) == 'C'
		ControlType := 'C'
	ELSEIF _AdoType (FieldName,i) == 'D'
		ControlType := 'D'
	ELSEIF _AdoType (FieldName,i) == 'L'
		ControlType := 'L'
		Ldelta := 1
	ELSEIF _AdoType (FieldName,i) == 'M'
		ControlType := 'M'
	ELSEIF _AdoType (FieldName,i) == 'N'
		ControlType := 'I'
	ELSEIF _AdoType (FieldName,i) == 'F'
		ControlType := 'F'
	ENDIF
	_HMG_SYSDATA [ 109 ] := GetActiveWindow()
	IF ControlType = 'M'
		nPos = ( This.CellHeight * 5 ) + 6 + lDelta
	ELSE
		nPos = This.CEllHeight + 6 + ldelta
	ENDIF
	
	DEFINE WINDOW _InPlaceEdit ;
		AT This.CellRow + GridRow - _HMG_SYSDATA [ 18 ] [i] - 1 , This.CellCol + GridCol - _HMG_SYSDATA [ 19 ] [i] + 2 ;
		WIDTH This.CellWidth ;
		HEIGHT nPos ; /*This.CellHeight + 6 + Ldelta ;*/
		MODAL ;
		NOCAPTION ;
		NOSIZE;
		ON INIT (_InPlaceEdit.Control_1.Setfocus )
	
	
		ON KEY CONTROL+W ACTION IF ( _IsWindowActive ( '_InPlaceEdit' ) , _AdoInPlaceEditOk ( i , Fieldname , _InPlaceEdit.Control_1.Value , ControlType , aValid , CellColIndex , sFieldName , _GridWorkArea , aValidMessages , lock , aInputItems ) , Nil )
		ON KEY RETURN ACTION IF ( _IsWindowActive ( '_InPlaceEdit' ) , _AdoInPlaceEditOk ( i , Fieldname , _InPlaceEdit.Control_1.Value , ControlType , aValid , CellColIndex , sFieldName , _GridWorkArea , aValidMessages , lock , aInputItems ) , Nil )
		ON KEY ESCAPE ACTION ( _HMG_SYSDATA [ 256 ] := .T. , _BrowseAdoCancel(i), _InPlaceEdit.Release , setfocus ( _HMG_SYSDATA [3] [i] ) )
	
		If lInputItems == .T.
	
			* Fill Items Array
	
			For p := 1 To Len ( aInputItems [ CellColIndex ] )
				aadd ( aItems , aInputItems [ CellColIndex ] [p] [1] )
			Next p
			
			* Fill Values Array
	
			For p := 1 To Len ( aInputItems [ CellColIndex ] )
				aadd ( aValues , aInputItems [ CellColIndex ] [p] [2] )
			Next p
	
			ii := aScan ( aValues , CellData )
	
			if ii == 0
				ii := 1
			endif
	
			DEFINE COMBOBOX Control_1
				FONTNAME BFN
				FONTSIZE BFS
				ROW 0
				COL 0
				ITEMS aItems
				WIDTH This.CellWidth 
				VALUE ii
			END COMBOBOX
	
		ElseIf ControlType == 'C'
			CellData := rtrim ( CellData )
	
			DEFINE TEXTBOX Control_1
				FONTNAME BFN
				FONTSIZE BFS
	
				ROW 0
				COL 0
				WIDTH This.CellWidth 
				HEIGHT This.CellHeight + 6
				VALUE CellData
				MAXLENGTH Width 
	
				IF VALTYPE ( AINPUTMASK ) == 'A'
					IF LEN ( AINPUTMASK ) >= CellColIndex
						IF VALTYPE ( AINPUTMASK [CellColIndex] ) == 'C'
							IF ! EMPTY ( AINPUTMASK [CellColIndex] )
								INPUTMASK AINPUTMASK [CellColIndex]
							ENDIF
						ENDIF
					ENDIF
				ENDIF
	
			END TEXTBOX
	
		ElseIf ControlType == 'M'
			*-CellData := rtrim ( CellData )
	
			DEFINE EDITBOX Control_1
				FONTNAME BFN
				FONTSIZE BFS
				ROW 			0
				COL 			0
				WIDTH  			This.CellWidth 
				HEIGHT 			nPos /*This.CellHeight + 6*/
				VALUE 			CellData
				NOHSCROLLBAR 	.T.
			END EDITBOX
			
		ElseIf ControlType == 'D'
	
			DEFINE DATEPICKER Control_1
				FONTNAME BFN
				FONTSIZE BFS
				ROW 0
				COL 0
				HEIGHT This.CellHeight + 6
				WIDTH This.CellWidth 
				VALUE CellData
				UPDOWN .T.
				SHOWNONE .T.
			END DATEPICKER
	
		ElseIf ControlType == 'L'
	
			DEFINE COMBOBOX Control_1
				FONTNAME BFN
				FONTSIZE BFS
				ROW 0
				COL 0
				ITEMS { '.T.','.F.' }
				WIDTH This.CellWidth 
				VALUE If ( CellData , 1 , 2 )
			END COMBOBOX
	
		ElseIf ControlType == 'I'
	
			DEFINE TEXTBOX Control_1
				FONTNAME BFN
				FONTSIZE BFS
				ROW 0
				COL 0
				NUMERIC	.T.
				WIDTH This.CellWidth 
				HEIGHT This.CellHeight + 6
				VALUE CellData
	
				IF VALTYPE ( AINPUTMASK ) == 'A'
					IF LEN ( AINPUTMASK ) >= CellColIndex
						IF VALTYPE ( AINPUTMASK [CellColIndex] ) == 'C'
							IF ! EMPTY ( AINPUTMASK [CellColIndex] )
								INPUTMASK AINPUTMASK [CellColIndex]
							ELSE
								MAXLENGTH Width
							ENDIF
						ELSE
							MAXLENGTH Width
						ENDIF
					ELSE
						MAXLENGTH Width
					ENDIF
				ELSE
					MAXLENGTH Width
				ENDIF
	
				IF VALTYPE ( AFORMAT ) == 'A'
					IF LEN ( AFORMAT ) >= CellColIndex
						IF VALTYPE ( AFORMAT [CellColIndex] ) == 'C'
							IF ! EMPTY ( AFORMAT [CellColIndex] )
								FORMAT AFORMAT [CellColIndex]
							ENDIF
						ENDIF
					ENDIF
				ENDIF
	
			END TEXTBOX
	
		ElseIf ControlType == 'F'
	
			DEFINE TEXTBOX Control_1
				FONTNAME BFN
				FONTSIZE BFS
				ROW 0
				COL 0
				NUMERIC	.T.
				WIDTH This.CellWidth 
				HEIGHT This.CellHeight + 6
				VALUE CellData
	
				IF VALTYPE ( AINPUTMASK ) == 'A'
					IF LEN ( AINPUTMASK ) >= CellColIndex
						IF VALTYPE ( AINPUTMASK [CellColIndex] ) == 'C'
							IF ! EMPTY ( AINPUTMASK [CellColIndex] )
								INPUTMASK AINPUTMASK [CellColIndex]
							ELSE
								INPUTMASK Replicate ( '9', Width - Decimals - 1 ) + '.' + Replicate ( '9', Decimals ) 
							ENDIF
						ELSE
							INPUTMASK Replicate ( '9', Width - Decimals - 1 ) + '.' + Replicate ( '9', Decimals ) 
						ENDIF
					ELSE
						INPUTMASK Replicate ( '9', Width - Decimals - 1 ) + '.' + Replicate ( '9', Decimals ) 
					ENDIF
				ELSE
					INPUTMASK Replicate ( '9',  9 ) + '.' + Replicate ( '9', 3) 
				ENDIF
	
				IF VALTYPE ( AFORMAT ) == 'A'
					IF LEN ( AFORMAT ) >= CellColIndex
						IF VALTYPE ( AFORMAT [CellColIndex] ) == 'C'
							IF ! EMPTY ( AFORMAT [CellColIndex] )
								FORMAT AFORMAT [CellColIndex]
							ENDIF
						ENDIF
					ENDIF
				ENDIF	
			END TEXTBOX	
		EndIf	
	END WINDOW	
	ACTIVATE WINDOW _InPlaceEdit	
	_HMG_SYSDATA [ 109 ] := 0
RETURN NIL

STATIC PROCEDURE _BrowseAdoCancel(I)
	IF _HMG_SYSDATA [ 39 ] [i] [2] == .T.
		IF _HMG_SYSDATA[22][I]:RecordCount > 0
			_HMG_SYSDATA[22][I]:MoveLast()
		ENDIF
		_BrowseAdoRefresh('','',i)
	ENDIF
	_HMG_SYSDATA [ 39 ] [i] [2] = .F.		
	setfocus ( _HMG_SYSDATA [3] [i] ) 	
RETURN

///////////////////////////////////////////////////////////////////////////////
PROCEDURE _AdoInPlaceEditOk ( i , Fieldname , r , ControlType , aValid , CellColIndex , sFieldName , AreaName , aValidMessages , lock , aInputItems )
///////////////////////////////////////////////////////////////////////////////
	LOCAL b , Result , mVar , TmpName, _BrowseArea, nRecno 

	IF ControlType == 'X' .Or. ControlType == 'L'
		IF GetDroppedState ( GetControlHandle ('Control_1' , '_InPlaceEdit' ) ) == 1
			SendMessage ( GetControlHandle ('Control_1' , '_InPlaceEdit' ) , CB_SHOWDROPDOWN , 0 , 0 )
			InsertReturn()
			RETURN
		ENDIF
	ENDIF
	
	_BrowseArea:= _HMG_SYSDATA[22][i]
	
	IF VALTYPE ( aValid ) == 'A'
		IF LEN ( aValid ) >= CellColIndex
			IF aValid [ CellColIndex ] != Nil
				Result := _GetValue ( 'Control_1' , '_InPlaceEdit' )
				IF ControlType == 'L'
					Result := IF ( Result == 0 .or. Result == 2 , .F. , .T. )
				ENDIF
				TmpName := 'MemVar' + sFieldname
				mVar 	:= TmpName
				&mVar 	:= Result			
				
				b := EVAL ( aValid [ CellColIndex ] )
				*- SI ESTABA EN EOF SE DEVUELVE A ESA POSICION.
				IF _HMG_SYSDATA[39][I][2] == .T.				
					_BrowseArea:MoveLast()
					_BrowseArea:MoveNext()
				ENDIF
				
				IF b == .f.
					IF VALTYPE ( aValidMessages ) == 'A'
						IF LEN ( aValidMessages ) >= CellColIndex
							IF aValidMessages [CellColIndex] != Nil
								MsgExclamation ( aValidMessages [CellColIndex] )
							ELSE
								MsgExclamation (_HMG_SYSDATA [ 136 ][11])
							ENDIF							
						ELSE
							MsgExclamation (_HMG_SYSDATA [ 136 ][11])
						ENDIF						
					ELSE
						MsgExclamation (_HMG_SYSDATA [ 136 ][11])
					ENDIF
					*- AGREGUE ESTE RETURN PARA VER QUE PASA SI LA VALIDACION ES .F.; FUNCIONA BIEN.
					*- SE SUPONE QUE AL DEVOLVER EL ERROR NO SE CANCELA LA EDICIN SOLO CON ESCAPE.
					RETURN
				ELSE
					 _AdoInplaceEditSave ( i , sFieldname , AreaName , r , lock , ControlType , aInputItems , CellColIndex, .T. )
				ENDIF
			ELSE
			 	_AdoInplaceEditSave ( i , sFieldname , AreaName , r , lock , ControlType , aInputItems , CellColIndex, .t.)
			ENDIF
		ENDIF
	ELSE
	 	_AdoInplaceEditSave ( i , sFieldname , AreaName , r , lock , ControlType , aInputItems , CellColIndex, .t. )
	ENDIF
	_HMG_SYSDATA [ 256 ] 		:= .F.
	_HMG_SYSDATA [ 39 ] [i] [2] := .F.
	setfocus ( _HMG_SYSDATA [3] [i] )
RETURN

*-----------------------------------------------------------------------------*
STATIC PROCEDURE _AdoInplaceEditSave ( i , Fieldname , Alias , r , lock , ControlType , aInputItems , CellColIndex, Append )
*-----------------------------------------------------------------------------*
	LOCAL _BrowseArea := _HMG_SYSDATA[22] [i], x
   	IF VALTYPE( r ) = 'N'
		IF ControlType == 'L'
         	r := IF ( r == 0 .or. r == 2 , .F. , .T. )
      	ELSEIF ControlType == 'X'
         	r := aInputItems [ CellColIndex ] [ r ] [ 2 ]
      	ENDIF
   	ENDIF
   	TRY
   		IF _HMG_SYSDATA[39][I][2] == .T.
   			_BrowseArea:AddNew()
   		ENDIF
		_BrowseArea:Fields( Fieldname ):Value	:= r
		_BrowseArea:Update()
   		IF _HMG_SYSDATA[39][I][2] == .T.
   			_BrowseArea:Requery()
   			/* Cuando la consulta no esta ordenada por el id de la tabla
   			el recordset se ordena al grabar el campo de orden.
   			por lo tanto, se debe ubicar el registro ya que el Absoluteposition
   			queda de acuerdo al orden en que quede nuestro nuevo registro 
   			*/
   			DO CASE
   			CASE _ADOTYPE( Fieldname, _BrowseArea ) = 'N'
				x = Fieldname+'='+HB_VALTOSTR(R)
   			CASE _ADOTYPE( Fieldname, _BrowseArea ) = 'C'
	   			x = Fieldname+"='"+HB_VALTOSTR(R)+"'"
   			CASE _ADOTYPE( Fieldname, _BrowseArea ) = 'L'
	   			x = Fieldname+'='+HB_VALTOSTR(R)
   			CASE _ADOTYPE( Fieldname, _BrowseArea ) = 'D'
   				x = Fieldname+'=#'+HB_VALTOSTR(R)+'#'
   			ENDCASE
   			_BrowseArea:Movefirst()
   			_BrowseArea:find( x )			
   		ENDIF
   	CATCH e
		MsgStop("Operacin: "+e:operation+hb_osnewline()+"Descripcin: "+e:Description)	
   	END TRY
	_BrowseAdoRefresh ( '' , '' , i )
   _InPlaceEdit.Release
	_HMG_SYSDATA [ 39 ] [i] [2] = .F.		
RETURN

*------------------------------------------------------------------------------*
PROCEDURE AdoProcessInPlaceKbdEdit(i)
*------------------------------------------------------------------------------*
	LOCAL r
	LOCAL IPE_MAXCOL
	LOCAL TmpRow
	LOCAL xs,xd

	IF _HMG_SYSDATA [ 15 ] [ i ] == .F.
		RETURN
	ENDIF

	IF LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] ) == 0
		RETURN
	ENDIF

	IPE_MAXCOL := LEN ( _HMG_SYSDATA [ 31 ] [i] )
	_HMG_SYSDATA[340] := 1
	IF _HMG_SYSDATA[22][I]:AbsolutePosition == -1 .OR. _HMG_SYSDATA[22][I]:AbsolutePosition == -2 .OR. _HMG_SYSDATA[22][I]:AbsolutePosition == -3
		_HMG_SYSDATA[39][I][2] := .T.
	ENDIF
	IF _HMG_SYSDATA[22][I]:Recordcount > 0
		IF _HMG_SYSDATA [ 39 ] [i] [2] == .T.
			_BrowseAdoAppend ( '' , '' , i )
		ENDIF
	ENDIF

	DO WHILE .T.
		TmpRow := LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] )
		IF TmpRow != _HMG_SYSDATA [ 341 ] 
			_HMG_SYSDATA [ 341 ] := TmpRow

			IF LEN ( _HMG_SYSDATA [ 14 ] [i] ) > 0 
				_HMG_SYSDATA [ 340 ] := 2
			ELSE
				_HMG_SYSDATA [ 340 ] := 1
			ENDIF
		ENDIF

		_HMG_SYSDATA [ 195 ] := _HMG_SYSDATA [ 341 ]
		_HMG_SYSDATA [ 196 ] := _HMG_SYSDATA [ 340 ]

		IF _HMG_SYSDATA [ 340 ] == 1
			r := LISTVIEW_GETITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 )
		ELSE
			r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 , _HMG_SYSDATA [ 340 ] - 1 )
		ENDIF

		xs :=	( ( _HMG_SYSDATA [ 19 ] [i] + r [2] ) +( r[3] ))  -  ( _HMG_SYSDATA [ 19 ] [i] + _HMG_SYSDATA [ 20 ] [i] )
		xd := 20

		IF xs > -xd 
			ListView_Scroll( _HMG_SYSDATA [3] [i] ,	xs + xd , 0 ) 
		ELSE
        		IF r [2] < 0
                	     ListView_Scroll( _HMG_SYSDATA [3] [i] , r[2]	, 0 )
	            ENDIF
		ENDIF           

		IF _HMG_SYSDATA [ 340 ] == 1
			r := LISTVIEW_GETITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 )
		ELSE
			r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 , _HMG_SYSDATA [ 340 ] - 1 )
		ENDIF

		_HMG_SYSDATA [ 197 ] := _HMG_SYSDATA [ 18 ] [i] + r [1]
		_HMG_SYSDATA [ 198 ] := _HMG_SYSDATA [ 19 ] [i] + r [2]
		_HMG_SYSDATA [ 199 ] := r[3]
		_HMG_SYSDATA [ 200 ] := r[4]
		_BrowseAdoEdit ( _HMG_SYSDATA [3][i] , _HMG_SYSDATA [ 39 ] [i] [4] , _HMG_SYSDATA [ 39 ] [i] [5] , _HMG_SYSDATA [ 39 ] [i] [3] , _HMG_SYSDATA [  9 ] [i] , .f. , _HMG_SYSDATA [ 15 ] [i] , _HMG_SYSDATA [ 39 ] [i] [7] )  
		_HMG_SYSDATA [ 203 ] := 0
		_HMG_SYSDATA [ 231 ] := ''

		_HMG_SYSDATA [ 195 ] := 0
		_HMG_SYSDATA [ 196 ] := 0
		_HMG_SYSDATA [ 197 ] := 0
		_HMG_SYSDATA [ 198 ] := 0
		_HMG_SYSDATA [ 199 ] := 0
		_HMG_SYSDATA [ 200 ] := 0

		IF _HMG_SYSDATA [ 256 ] == .T.
			IF _HMG_SYSDATA [ 340 ] == IPE_MAXCOL
				IF LEN ( _HMG_SYSDATA [ 14 ] [i] ) > 0 
					_HMG_SYSDATA [ 340 ] := 2
				ELSE
					_HMG_SYSDATA [ 340 ] := 1
				ENDIF
				ListView_Scroll( _HMG_SYSDATA [3] [i] ,	-10000  , 0 ) 
			ENDIF
			EXIT
		ELSE
			_HMG_SYSDATA [ 340 ]++
			IF _HMG_SYSDATA [ 340 ] > IPE_MAXCOL
				IF LEN ( _HMG_SYSDATA [ 14 ] [i] ) > 0 
					_HMG_SYSDATA [ 340 ] := 2
				ELSE
					_HMG_SYSDATA [ 340 ] := 1
				ENDIF

				ListView_Scroll( _HMG_SYSDATA [3] [i] ,	-10000  , 0 ) 
				EXIT
			ENDIF
		ENDIF		
	ENDDO
RETURN
*------------------------------------------------------------------------------*
PROCEDURE _BrowseAdoSync (i)
*------------------------------------------------------------------------------*
	LOCAL _BrowseArea
	LOCAL _CurrentValue
	
    *October 13, 2009 	
	_BrowseArea 	:= _HMG_SYSDATA [ 22 ] [i]
	
	IF _BrowseArea:recordcount > 0
		_CurrentValue = _BrowseAdoGetValue('','',i)
		IF _CurrentValue > 0 .and. _CurrentValue <= _BrowseArea:Recordcount
			_BrowseArea:AbsolutePosition	:= _CurrentValue
		ELSE
			IF _BrowseArea:eof()
				_BrowseArea:AbsolutePosition := _BrowseArea:Recordcount
			ELSE
				_BrowseArea:AbsolutePosition := 1
			ENDIF
		ENDIF
	ENDIF
RETURN
*------------------------------------------------------------------------------*
PROCEDURE _BrowseAdoOnChange (i)
*------------------------------------------------------------------------------*
	_BrowseAdoSync (i)
	_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [i] , i )
RETURN

*-----------------------------------------------------------------------------*
PROCEDURE _BrowseAdoAppend ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
	LOCAL i , _Alias , _RecNo , _BrowseArea , _BrowseRecMap   , _DeltaScroll := { Nil , Nil , Nil , Nil } , _NewRec , aTemp

	IF PCOUNT() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	ELSE
		i := z
	ENDIF

	_BrowseRecMap 	:= _HMG_SYSDATA [ 32 ] [i] 
	_Newrec 		:= _HMG_SYSDATA[22][i]:RecordCount + 1
	aTemp 			:= ARRAY ( LEN (_HMG_SYSDATA [ 31 ] [i]) )
	AFILL ( aTemp , '' )
	AADD ( _HMG_SYSDATA [ 32 ] [i] , _NewRec )
	AddListViewItems ( _HMG_SYSDATA [3][i] , aTemp , 0 )
	ListView_SetCursel ( _HMG_SYSDATA [3] [i] , LEN ( _HMG_SYSDATA [ 32 ] [i] ) )
	_HMG_SYSDATA [ 341 ] := 1
RETURN
*------------------------------------------------------------------------------*
PROCEDURE _BrowseAdoVscrollUpdate (i)
*------------------------------------------------------------------------------*
	LOCAL ActualRecord , RecordCount , KeyCount 
	LOCAL _WorkArea

	// If vertical scrollbar is used it must be updated
	IF _HMG_SYSDATA [ 5 ] [i] != 0	
		_WorkArea	:= _HMG_SYSDATA[22][i]
		ActualRecord:= _WorkArea:AbsolutePosition 
		RecordCount := _WorkArea:RecordCount
		*_HMG_SYSDATA [ 37 ] [i] := RecordCount
		IF RecordCount < 100
			SetScrollRange (_HMG_SYSDATA [  5 ] [i] , 2 , 1 , RecordCount , .t. )
			SetScrollPos   (_HMG_SYSDATA [  5 ] [i] , 2 , ActualRecord , 1 )
		ELSE
			SetScrollRange (_HMG_SYSDATA [  5 ] [i] , 2 , 1 , 100 , .t. )
			SetScrollPos   (_HMG_SYSDATA [  5 ] [i] , 2 , INT ( ActualRecord * 100 / RecordCount ) , 1 )
		ENDIF
	ENDIF
RETURN

*------------------------------------------------------------------------------*
PROCEDURE _BrowseAdoVscrollFastUpdate ( i , d )
*------------------------------------------------------------------------------*
	LOCAL ActualRecord , RecordCount

	// If vertical scrollbar is used it must be updated
	If _HMG_SYSDATA [  5 ] [i] != 0
		IF _HMG_SYSDATA [ 22 ] [i]:Recordcount > 0
			RecordCount := _HMG_SYSDATA [ 22 ] [i]:RecordCount
			ActualRecord:=_HMG_SYSDATA [ 22 ] [i]:AbsolutePosition
			If ValType(RecordCount) <> 'N'
				Return
			EndIf
        	
			If RecordCount == 0
				Return
			EndIf
        	
			If RecordCount < 100
	    	    ActualRecord := GetScrollPos(_HMG_SYSDATA [  5 ] [i],2)
	    	    ActualRecord := ActualRecord + d
				SetScrollRange (_HMG_SYSDATA [  5 ] [i] , 2 , 1 , RecordCount , .t. )
				SetScrollPos ( _HMG_SYSDATA [  5 ] [i] , 2 , ActualRecord , 1 )
			else
				SetScrollRange(_HMG_SYSDATA [  5 ] [i] , 2 , 1 , 100 , .t. )
				SetScrollPos  (_HMG_SYSDATA [  5 ] [i] , 2 , INT ( ActualRecord * 100 / RecordCount ) , 1 )
			EndIf
		ENDIF
	EndIf

Return

*------------------------------------------------------------------------------*
Function _SetBrowseAdoAllowEdit ( cControlName , cWindowName , lValue )
*------------------------------------------------------------------------------*
Local i

	If ValType ( lValue ) <> 'L'
		MsgMiniGuiError("Wrong Parameter Type (Logical Required). Program terminated" )
	Endif
	
	i := GetControlIndex ( cControlName , cWindowName )

	_HMG_SYSDATA [ 39 ] [i] [6] := lValue

Return Nil

*------------------------------------------------------------------------------*
Function _SetBrowseAdoAllowAppend ( cControlName , cWindowName , lValue )	
*------------------------------------------------------------------------------*
Local i

	If ValType ( lValue ) <> 'L'
		MsgMiniGuiError("Wrong Parameter Type (Logical Required). Program terminated" )
	Endif
	
	i := GetControlIndex ( cControlName , cWindowName )

	_HMG_SYSDATA [ 39 ] [i] [2] := lValue

Return Nil

*------------------------------------------------------------------------------*
Function _SetBrowseAdoAllowDelete ( cControlName , cWindowName , lValue )	
*------------------------------------------------------------------------------*
Local i

	If ValType ( lValue ) <> 'L'
		MsgMiniGuiError("Wrong Parameter Type (Logical Required). Program terminated" )
	Endif
	
	i := GetControlIndex ( cControlName , cWindowName )

	_HMG_SYSDATA [ 25 ] [i] := lValue

Return Nil

*------------------------------------------------------------------------------*
Function _SetBrowseAdoInputItems ( cControlName , cWindowName , aValue ) 
*------------------------------------------------------------------------------*

	If ValType ( aValue ) <> 'A'
		MsgMiniGuiError("Wrong Parameter Type (Array Required). Program terminated" )
	Endif

	i := GetControlIndex ( cControlName , cWindowName )

	_HMG_SYSDATA [ 39 ] [ i ] [ 7 ] := aValue

Return Nil

*------------------------------------------------------------------------------*
Function _SetBrowseAdoDisplayItems ( cControlName , cWindowName , aValue ) 
*------------------------------------------------------------------------------*

	If ValType ( aValue ) <> 'A'
		MsgMiniGuiError("Wrong Parameter Type (Array Required). Program terminated" )
	Endif

	i := GetControlIndex ( cControlName , cWindowName )

	_HMG_SYSDATA [ 39 ] [ i ] [ 8 ] := aValue

Return Nil

*------------------------------------------------------------------------------*
Function _GetBrowseAdoInputItems ( cControlName , cWindowName )	
*------------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( cControlName , cWindowName )

Return _HMG_SYSDATA [ 39 ] [i] [7] 

*------------------------------------------------------------------------------*
Function _GetBrowseAdoDisplayItems ( cControlName , cWindowName )	
*------------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( cControlName , cWindowName )

Return _HMG_SYSDATA [ 39 ] [i] [8] 

*------------------------------------------------------------------------------*
Function _GetBrowseAdoAllowEdit ( cControlName , cWindowName )	
*------------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( cControlName , cWindowName )

Return _HMG_SYSDATA [ 39 ] [i] [6] 

*------------------------------------------------------------------------------*
Function _GetBrowseAdoAllowAppend ( cControlName , cWindowName , lValue )	
*------------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( cControlName , cWindowName )

Return _HMG_SYSDATA [ 39 ] [i] [2] 

*------------------------------------------------------------------------------*
Function _GetBrowseAdoAllowDelete ( cControlName , cWindowName , lValue )	
*------------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( cControlName , cWindowName )

Return _HMG_SYSDATA [ 25 ] [i]

*------------------------------------------------------------------------------*
Function _BrowseAdoCharMaskDisplay ( cText , cMask )
*------------------------------------------------------------------------------*
	Local i, Out, m, t
	Out := ''
	For i := 1 To Len ( cMask )
		t := SubStr ( cText , i , 1 )	
		m := SubStr ( cMask , i , 1 )
		if	m = '!'
			Out := Out + upper (t)
		elseif	m = 'A' .or. m = '9'
			Out := Out + t
		else
			Out := Out + m
		endif
	Next i
Return Out

PROCEDURE _BrowseAdoSetFocus( cWindow , cControl)
	LOCAL i := 0
	i = GetControlIndex( cControl, cWindow )
	IF i > 0
		SetFocus ( _HMG_SYSDATA[3][I] ) 
		_HMG_SYSDATA [63] := .T.
	ELSE
		_HMG_SYSDATA [63] := .F.
	ENDIF
RETURN 

PROCEDURE _BrowseAdoEnable ( cWindow , cControl, lValue )
	If GetControlType ( cControl , cWindow ) == 'BROWSEADO'
		EnableWindow ( GetControlHandle ( cControl , cWindow ) )
		_HMG_SYSDATA [63] := .T.
	else
		_HMG_SYSDATA [63] := .F.
	endif
RETURN 

PROCEDURE _BrowseAdoDisable (cWindow,cControl)
	If GetControlType ( cControl , cWindow ) == 'BROWSEADO'
		DisableWindow ( GetControlHandle ( cControl , cWindow ) )
		_HMG_SYSDATA [63] := .T.
	else
		_HMG_SYSDATA [63] := .F.
	endif
RETURN 

FUNCTION _Fieldpos(cfield,i)
	LOCAL _WorkArea := _HMG_SYSDATA[22][I]
	LOCAL nPos := 0, P := 0
	FOR p= 0 TO _WorkArea:Fields:Count() - 1
		IF UPPER( _WorkArea:Fields(p):Name ) == UPPER( cField )
			nPOs := p
			EXIT
		ENDIF
	NEXT	
RETURN npos

FUNCTION _AdoGetValue( cWindow , cControl )
	LOCAL BrowseArea 	
	LOCAL i := 0, nRecno := 0

	i := GetControlIndex(cControl, cWindow)
	IF i > 0
		BrowseArea	:= _HMG_SYSDATA[22] [i]	
		_HMG_SYSDATA[63] := .T.
		nRecno 		:= BrowseArea:AbsolutePosition
	ELSE
		_HMG_SYSDATA[63] := .F.	
	ENDIF
RETURN nRecno

FUNCTION _AdoSetValue( cWindow, cControl,cProp,nValue )
	LOCAL BrowseArea 	
	LOCAL i :=0
	i:= GetControlIndex(cControl,cWindow)
	IF i > 0
		_HMG_SYSDATA[63] := .T.
		BrowseArea:= _HMG_SYSDATA[22] [i]	
		IF BrowseArea:RecordCount > 0
			IF nValue < 1
				nValue	:= 1
			ELSEIF nValue > BrowseArea:RecordCount
				nValue	= BrowseArea:Recordcount
			ENDIF
			BrowseArea:AbsolutePosition := nValue
			_BrowseAdoRefresh('','',i)
			BrowseArea:AbsolutePosition := nValue
		ENDIF
	ELSE
		_HMG_SYSDATA[63] := .F.
		Msgstop('Control Not found')
	ENDIF
RETURN NIL

PROCEDURE _BrowseAdoSetLock( cwindow, cControl, cProp, lValue)
	LOCAL i:= GetControlIndex(cControl,cWindow)
	IF i > 0	
		_HMG_SYSDATA[9][I] 	:= lValue
	ENDIF
RETURN

FUNCTION _BrowseAdoGetLock( cwindow, cControl, cProp)
	LOCAL i:= GetControlIndex(cControl,cWindow)
	IF i > 0	
		RETURN _HMG_SYSDATA[9][I] 
	ENDIF
RETURN .F.

PROCEDURE _BrowseAdoSetRefresh( cwindow, cControl, cProp, lValue)
	LOCAL i:= GetControlIndex(cControl,cWindow)
	IF i > 0	
		_BrowseAdoRefresh('','',i)
	ENDIF
RETURN

PROCEDURE _BrowseAdoSize( cwindow, cControl)
	LOCAL i:= GetControlIndex(cControl,cWindow)
	IF i > 0	
		ReDrawWindow( _HMG_SYSDATA[3][I])
		_BrowseAdoRefresh('','',i)
	ENDIF
RETURN

PROCEDURE _BrowseAdoMoveFirst( cWindow, cControl )
	_BrowseAdoUp( cControl, cWindow )
RETURN

PROCEDURE _BrowseAdoAdjustScroll(i)
	IF _HMG_SYSDATA[5][I] > 0
		MoveWindow (_HMG_SYSDATA [  3 ] [i], ;
					_HMG_SYSDATA [ 19 ] [i], ;
					_HMG_SYSDATA [ 18 ] [i], ;
					_HMG_SYSDATA [ 20 ] [i] - GETVSCROLLBARWIDTH() , ;
					_HMG_SYSDATA [ 21 ] [i] , .t. )	
								
		MoveWindow (_HMG_SYSDATA [  5 ] [i], ;
					_HMG_SYSDATA [ 19 ] [i] + _HMG_SYSDATA [ 20 ] [i] - GETVSCROLLBARWIDTH() 	, ;
					_HMG_SYSDATA [ 18 ] [i] , ;
					GetWindowWidth( _HMG_SYSDATA [ 5 ] [i]), ;
					GetWindowHeight(_HMG_SYSDATA [ 5 ] [i]) , ;
					.t. )			
		MoveWindow ( _HMG_SYSDATA [  5 ] [i] , _HMG_SYSDATA [ 19 ][i]+_HMG_SYSDATA [ 20 ][i] - GETVSCROLLBARWIDTH() , _HMG_SYSDATA [ 18 ][i] , GETVSCROLLBARWIDTH() , _HMG_SYSDATA [ 21 ][i] , .t. )
		MoveWindow ( _HMG_SYSDATA [ 39 ] [i] [1], _HMG_SYSDATA [ 19 ][i]+_HMG_SYSDATA [ 20 ][i] - GETVSCROLLBARWIDTH() , _HMG_SYSDATA [ 18 ][i] + _HMG_SYSDATA [ 21 ][i] - GETHSCROLLBARHEIGHT() , 0 , 0 , .t. )								
		ReDrawWindow ( _HMG_SYSDATA [3] [i] )											
	ENDIF
RETURN 

*-----------------------------------------------------------------------------*
Function _BrowseSetBackColor ( ParentForm , ControlName, cType, Value  )
*-----------------------------------------------------------------------------*
Local i , f

	if valtype(Value) != 'A'	
		MSGINFO('RGB color not valid')
		RETURN NIL
	ENDIF
	if value[1] == Nil .or. value[2] == Nil .or. value[3] == Nil 
		Return Nil
	EndIf

	i := GetControlIndex ( ControlName, ParentForm )

	IF  _HMG_SYSDATA [1] [i] == 'BROWSEADO'

		ListView_SetBkColor ( _HMG_SYSDATA [3] [i], value[1] , value[2] , value[3] )
		ListView_SetTextBkColor ( _HMG_SYSDATA [3] [i], value[1] , value[2] , value[3] )
		*RedrawWindow ( _HMG_SYSDATA [3] [i] )
		_BrowseAdoRefresh ( ControlName , ParentForm , I )		
	EndIf

Return Nil

Procedure _BrowseSetDelete( cWindow, cControl, cType, Value )
	LOCAL i := GetControlIndex( cControl, cWindow )
	IF VALTYPE( Value ) == 'L' 
		IF _HMG_SYSDATA[1][I] == 'BROWSEADO'
			_HMG_SYSDATA [ 25 ] [i] := Value
		ENDIF
	ENDIF
return

Function _BrowseGetDelete( cWindow, cControl )
	LOCAL i := GetControlIndex( cControl, cWindow )
	LOCAL lValue := .F.
	IF _HMG_SYSDATA[1][I] == 'BROWSEADO'	
		lValue	:= _HMG_SYSDATA [ 25 ] [i] 
	ENDIF
return lValue
